NOTE PROGRAM GENERIC.PRG 01.01.01
NOTE PROGRAMMER D. ALLEN
NOTE CREATED MAR 14, 1998
NOTE UPDATED FEB 02, 2000
NOTE COPYRIGHT(C) 1998
*
*    THE PURPOSE OF THIS PROGRAM IS TO CONVERT GENERIC/TEXT ONLY OUTPUT
*    FILE TO AN ASCII TEXT FILE A USER CAN VIEW OR PRINT
*
*    PARAMETERS:
*      cSRC            -  GENERIC/TEXT ONLY FILE
*      cDES            -  ASCII FILE
*
PARAMETERS cSRC, cDES

PRIVATE ALL EXCEPT cSRC, cDES

PRIVATE nPARAMETERS      && bug  !!!!!!!
nPARAMETERS = PARAMETERS()

CLOSE ALL
SET SAFETY OFF
SET TALK OFF

cSRC = IIF(TYPE("cSRC") = "C", UPPER(ALLTRIM(cSRC)), "")
cDES = IIF(TYPE("cDES") = "C", UPPER(ALLTRIM(cDES)), "")

cPATH_SEP = "\"
cDRIV_SEP = ":\"

SET ALTERNATE OFF
SET ALTERNATE TO
SET AUTOSAVE OFF
SET BELL OFF
SET BLINK ON
SET CENTURY OFF
SET CLEAR ON
SET COMPATIBLE OFF
SET CONFIRM OFF
SET CONSOLE ON
SET CURRENCY LEFT
SET DATE AMERICAN
SET DECIMALS TO 2
SET DELETED ON
SET DEVICE TO SCREEN
SET EXACT ON
SET EXCLUSIVE ON
SET FIELDS OFF
SET FIXED ON
SET FORMAT TO
SET FUNCTION "F2" TO ""
SET FUNCTION "F3" TO ""
SET FUNCTION "F4" TO ""
SET FUNCTION "F5" TO ""
SET FUNCTION "F6" TO ""
SET FUNCTION "F7" TO ""
SET FUNCTION "F8" TO ""
SET FUNCTION "F9" TO ""
SET FUNCTION "F10" TO ""
SET HEADING ON
SET INTENSITY ON
SET LOGERRORS ON
SET MEMOWIDTH TO 255
SET NEAR OFF
&& SET RESOURCE ON
SET SAFETY OFF
SET SCOREBOARD ON
SET STATUS OFF
SET SYSMENU OFF
SET TYPEAHEAD TO 128
SET UNIQUE OFF

DO CASE
CASE _DOS .OR. _UNIX
  SET BORDER TO DOUBLE
  SET CLOCK TO 00,SCOLS()-11
  SET CLOCK ON
  SET SHADOWS ON
  = SYS(2008,"I",2)
  = SYS(2008,"O",0)
  &&= INSMODE(.F.)
  &&= CAPSLOCK(.F.)
  &&= NUMLOCK(.F.)
CASE _WINDOWS .OR. _MAC
  MODIFY WINDOW SCREEN TITLE VERSION()
  SET CLOCK ON
  SET CLOCK STATUS
  SET STATUS BAR ON
ENDCASE

IF LEN(GETENV("DEBUG")) > 0 .AND. .NOT. "RUNTIME" $ UPPER(VERSION()) ;
                            .AND. .NOT. "EXE"     $ UPPER(VERSION())
  ON ESCAPE SUSPEND
  SET ESCAPE ON
  SET SYSMENU ON
ENDIF
*
*    MAIN ROUTINE
*
DO WHILE .T.

  CLEAR

  @ 1, 1 SAY "GENERIC 01.01.01"
  @ 2, 1 SAY "(c) 1998-2000 Dennis Allen"
  @ 3, 1 SAY "All rights reserved"

  DO WHILE .T.

    @ 5, 0
    @ 5, 1 SAY "Press [Esc] to abort"

    CLOSE ALL

    IF nPARAMETERS = 0
      STORE "" TO cDES
    ENDIF

    cSRC = PADR(cSRC,180)
    cDES = PADR(cDES,180)

    @  7, 1 SAY "Enter Generic/Text Only File: " GET cSRC FUNCTION "S40!"
    @ 11, 1 SAY "Enter ASCII Text Output File: " GET cDES FUNCTION "S40!"

    IF nPARAMETERS = 0
      READ
    ENDIF
    CLEAR GETS

    IF LASTKEY() = 27
      EXIT
    ENDIF

    cDES = IIF(EMPTY(cDES), STRTRAN(cSRC,".PRN",".MAN"), cDES)

    cSRC = cSRC + IIF(.NOT. EMPTY(cSRC) .AND. AT(".",cSRC) = 0,".PRN","")
    cDES = cDES + IIF(.NOT. EMPTY(cDES) .AND. AT(".",cDES) = 0,".MAN","")

    cSRC = FULLPATH(UPPER(ALLTRIM(cSRC)))
    cTMP = SUBSTR(cSRC,1,AT(".",cSRC)) + "TMP"
    cDES = FULLPATH(UPPER(ALLTRIM(cDES)))

    @ 5, 0
    @ 5, 1 SAY "Please Wait..."

    @  7, 1 SAY "Enter Generic/Text Only File: " GET cSRC FUNCTION "S40!"
    @ 11, 1 SAY "Enter ASCII Text Output File: " GET cDES FUNCTION "S40!"
    CLEAR GETS

    IF cSRC == cDES
      WAIT "Error: Source cannot equal destination" WINDOW
      nPARAMETERS = 0
      LOOP
    ENDIF

    IF !fnFILE(cSRC)
      WAIT "Error: " + cSRC + " does not exist" WINDOW
      nPARAMETERS = 0
      LOOP
    ENDIF

    DO LINEFEED WITH cSRC, cTMP

    IF !fnFILE(cTMP)
      WAIT "Error: " + cTMP + " could not be created" WINDOW
      nPARAMETERS = 0
      LOOP
    ENDIF

    STORE .T. TO bERASE

    DO FORMFEED WITH cTMP, cDES

    IF !fnFILE(cDES)
      WAIT "Error: " + cDES + " could not be created" WINDOW
      nPARAMETERS = 0
      LOOP
    ENDIF

    IF bERASE
      ERASE (cSRC)
      ERASE (cTMP)
    ENDIF

    DO DOCFEED WITH cDES

    EXIT
  ENDDO

  IF LASTKEY() = 27
    EXIT
  ENDIF

  IF nPARAMETERS < 2
    STORE 0 TO nPARAMETERS
    WAIT WINDOW
    IF LASTKEY() <> 27
      LOOP
    ENDIF
  ENDIF

  EXIT
ENDDO

CLOSE DATABASES

SET PRINT OFF
SET PRINT TO
SET CONSOLE ON
IF SYS(16,1) = SYS(16) .AND. .NOT. WEXIST("command")
  QUIT
ENDIF
RETURN
*
PROCEDURE LINEFEED
*
*    THIS PROCEDURE WILL EXECUTE A COPY FILE, REPLACING LINEFEEDS
*    WITH CARRIAGE RETURN/LINEFEEDS.
*
*    PARAMETERS:
*      cSRC      -  SOURCE FILE
*      cDES      -  DESTINATION FILE
*
*    VARIABLES:
*      bESC      -  FLAG, ESCAPE WAS PRESSED
*      cREC      -  CURRENT RECORD
*      nSRC      -  FILE HANDLE
*
PARAMETERS cSRC, cDES
IF TYPE("cSRC") <> "C" .OR. TYPE("cDES") <> "C"
  RETURN
ENDIF
IF cSRC == cDES
  RETURN
ENDIF

PRIVATE bESC, cREC, nSRC
nSRC = FOPEN(cSRC)
IF nSRC <= 0
  RETURN
ENDIF

ERASE (cDES)
IF _DOS
  SET PRINT TO (cDES)
ELSE
  SET PRINT TO (cDES) ADDITIVE
ENDIF
SET CONSOLE OFF
bESC=.F.
ON ESCAPE bESC = .T.
SET ESCAPE ON
DO WHILE .NOT. FEOF(nSRC) .AND. .NOT. bESC
  cREC = FREAD(nSRC,1000)
  cREC = STRTRAN(cREC, "{","{{}")
  cREC = STRTRAN(cREC,CHR(13)+CHR(10),CHR(10))
  cREC = STRTRAN(cREC,CHR(13)+CHR(32),CHR(10)+CHR(32))
  cREC = STRTRAN(cREC,CHR(13))
  cREC = STRTRAN(cREC,CHR(10),CHR(13)+CHR(10))
  ??? cREC
ENDDO
SET ESCAPE OFF
ON ESCAPE
SET PRINT TO
SET CONSOLE ON
= FCLOSE(nSRC)
RETURN
*
PROCEDURE FORMFEED
*
*    THIS PROCEDURE WILL REMOVE EXCESS LINEFEEDS BEFORE A FORMFEED.
*    A MAXIMUM OF 60 LINES PER PAGE IS ALLOWED.
*
*    PARAMETERS:
*      cSRC      -  SOURCE FILE
*      cDES      -  DESTINATION FILE
*
*
*     PUBLIC:
*      bERASE    -  FLAG, .T. = OK TO ERASE FILES
*
*    VARIABLES:
*      REC       -  ARRAY, OF RECORDS
*      bESC      -  FLAG, ESCAPE WAS PRESSED
*      cREC      -  CURRENT RECORD
*      nDES      -  FILE HANDLE
*      nMAX      -  MAXIMUM LINES PER PAGE
*      nPAGE     -  CURRENT PAGE #
*      nREC      -  CURRENT LENGTH OF REC
*      nSRC      -  FILE HANDLE
*      nTMP      -  TEMPORARY VARIABLE
*
PARAMETERS cSRC, cDES
IF TYPE("cSRC") <> "C" .OR. TYPE("cDES") <> "C"
  RETURN
ENDIF
IF cSRC == cDES
  RETURN
ENDIF

PRIVATE REC, bESC, cREC, nDES, nREC, nSRC, nTMP
nSRC = FOPEN(cSRC)
IF nSRC <= 0
  RETURN
ENDIF

ERASE (cDES)
nDES = FCREATE(cDES)
IF nDES <= 0
  RETURN
ENDIF

DIMENSION REC(67)
STORE 0 TO nREC, nPAGE

bESC=.F.
ON ESCAPE bESC = .T.
SET ESCAPE ON
DO WHILE .NOT. FEOF(nSRC) .AND. .NOT. bESC
  cREC = FGETS(nSRC)
  nREC = nREC + 1
  REC(nREC) = cREC
  IF LEN(cREC) > 80
    REC(nREC) = RTRIM(LEFT(cREC,80))
    && ?? CHR(7)
    && WAIT "Page "+ALLTRIM(STR(nPAGE+1))+", line "+STR(nREC,2)+" is longer than 80 characters"
    && STORE .F. TO bERASE
  ENDIF
  IF RIGHT(cREC,1) = CHR(12) .OR. nREC = 66
    nMAX = IIF(nPAGE=0,60,59)
    REC(nREC) = cREC + IIF(RIGHT(cREC,1) = CHR(12), "", CHR(12))

    nTMP = nREC - 1
    DO WHILE nTMP > 1 .AND. .NOT. EMPTY(REC(nTMP))
      nTMP = nTMP - 1
    ENDDO

    DO WHILE nREC > nMAX .AND. nTMP > 1 .AND. EMPTY(REC(nTMP)+REC(nTMP-1))
      = ADEL(REC,nTMP)
      nTMP = nTMP - 1
      nREC = nREC - 1
    ENDDO

    nTMP = 1
    DO WHILE nREC > nMAX .AND. nTMP <= nREC
      IF EMPTY(REC(nTMP))
        = ADEL(REC,nTMP)
        nTMP = nTMP - 1
        nREC = nREC - 1
      ENDIF
      nTMP = nTMP + 1
    ENDDO

    DO WHILE nREC < nMAX
      REC(nREC+1) = REC(nREC)
      REC(nREC)   = ""
      nREC = nREC + 1
    ENDDO

    IF nREC > nMAX
      ?? CHR(7)
      WAIT "Page "+ALLTRIM(STR(nPAGE+1))+" has more than "+STR(nMAX,2)+" lines/page" WINDOW
      STORE .F. TO bERASE
    ENDIF

    FOR nTMP = 1 TO nREC
      = FPUTS(nDES,REC(nTMP))
    ENDFOR
    nPAGE = nPAGE + 1

    STORE 0 TO nREC
  ENDIF
ENDDO

FOR nTMP = 1 TO nREC
  = FPUTS(nDES,REC(nTMP))
ENDFOR

SET ESCAPE OFF
ON ESCAPE
= FCLOSE(nDES)
= FCLOSE(nSRC)
RETURN
*
FUNCTION fnFILE
*
*    THIS FUNCTION RETURNS TRUE IF SPECIFIED FILE IS FOUND.
*
*    PARAMETERS:
*      cNAME     -  FILE NAME
*
PARAMETERS cNAME
RETURN IIF(_UNIX,FILE(cNAME), !SYS(2000,cNAME) == "")
*
PROCEDURE DOCFEED
*
*    THIS PROCEDURE WILL REMOVE CARRIAGE RETURN/LINEFEED AT THE END OF
*    THE DOCUMENT.
*
*    PARAMETERS:
*      cSRC      -  SOURCE FILE
*
*    VARIABLES:
*      nSRC      -  FILE HANDLE
*
PARAMETERS cSRC
IF TYPE("cSRC") <> "C"
  RETURN
ENDIF

PRIVATE nSRC
nSRC = FOPEN(cSRC, 12)
IF nSRC <= 0
  RETURN
ENDIF

= FSEEK(nSRC,-3,2)
IF FREAD(nSRC,3) == CHR(12)+CHR(13)+CHR(10)
  = FSEEK(nSRC,-3,2)
  = FWRITE(nSRC,'  '+CHR(12))
ENDIF
= FCLOSE(nSRC)
RETURN
