


                                       Preface


     Hard-Wire Four is a utility designed to allow the programmer to maintain
     a SCR.DBF driven Foxpro application.  HW4 is written in a dBASE IV
     compatible language called Foxpro.

     In essence, the programmer executes HW4, generating program code from
     the data dictionary.  This data dictionary, called SCR.DBF, defines the
     parameters necessary to maintain the database files within the given
     application.  How to arrange screen and browse layouts, for example.

     While the main focus of this manual is to outline the data dictionary,
     there are sections describing basic and advanced installation
     techniques.  To help the programmer actually create a SCR.DBF driven
     application.

     This manual will be using dMAIL4 as an example of a working multi-user
     application that uses the SCR.DBF data dictionary.  It is assumed,
     therefore, that the programmer has a copy of dMAIL4 to examine.

     This manual is not for the beginner.  We will not be discussing how to
     use MS-DOS, or Foxpro.  Examples will be brief, and there will be a lot
     of technical notes within the regular discussions.

     My advice is to peruse the contents of this manual to familiarize
     yourself with its information.  I would not even attempt to read this
     manual until I first looked at dMAIL4 (or similar SCR.DBF driven
     system).  Read the dMAIL4 user and configuration manuals.  You also
     might want to familiarize yourself with the dMAIL4 source code (a
     printout from FoxDoc might help).

























                                     - Page 1 -


                             Copyright/License/Warranty


     This document and the program Hard Wire Four ("the software") are
     copyrighted by the author.  The copyright owner hereby licenses you to
     use the software given these restrictions:

          o  the program shall be supplied in its original, unmodified
             form, which includes this documentation;

          o  for-profit use without a license is prohibited;

          o  the program may not be included - or bundled - with other
             goods or services.  Exceptions may be granted upon written
             request only.

          o  no fee is charged beyond a reasonable amount for the media
             and handling ($10 maximum suggested);

          There is no warranty of any kind.  The copyright owner may not
          be held liable for any damages, including any lost profits or
          other incidental or consequential damages arising out of or
          inability to use the software.  By using the software, you agree
          to this.

          Copyright (C) 1987-2002 Dennis Allen.  All rights reserved.  All
          trademarks mentioned herein belong to their respective owners.





























                                     - Page 2 -


                                  TABLE OF CONTENTS


     Preface...............................................................1
     Copyright/License/Warranty............................................2
     Defining the Data Dictionary..........................................5
      Defining dMAIL4 .....................................................5
      Defining the Data Dictionary Layout .................................7
      Defining the form number ............................................9
      Defining the Full Screen Form ......................................10
       Defining a field description ......................................10
       Defining a database field .........................................11
         Size Fields .....................................................12
       Defining an @ EDIT field ..........................................13
       Defining a Memo Field .............................................13
       Validating a database field .......................................14
       The WHEN clause ...................................................16
       The Browse clause .................................................17
       The Default clause ................................................17
       The Restore clause ................................................19
       Calculated fields .................................................20
       The Message clause ................................................20
       The Second Message clause .........................................21
       The GET_MEMO clause ...............................................21
       The Popup Clause ..................................................21
       The Description clause ............................................22
       The GET_READ clause ...............................................23
      Defining the [F]ind Type Form ......................................24
       Defining a field description ......................................24
       Defining an input field ...........................................24
       Validating an input field .........................................24
       The WHEN clause ...................................................25
       The Default clause ................................................25
       The Restore clause ................................................25
       The Message clause ................................................25
       The Second Message clause .........................................26
       The GET_MEMO clause ...............................................26
       The Popup clause ..................................................26
       The GET_READ clause ...............................................27
      Defining the Option Grid Form ......................................27
       Defining a field description ......................................27
       Defining an input field ...........................................28
       Displaying an @ EDIT field ........................................28
       Defining a memo field .............................................29
       Validating an input field .........................................29
       The WHEN clause ...................................................30
       The Default clause ................................................30
       The Restore clause ................................................30
       The Message clause ................................................30
       The Second Message clause .........................................31
       The GET_MEMO clause ...............................................31
       The Popup Clause ..................................................31
       The Description clause ............................................32
       The GET_READ clause ...............................................32
      dMAIL4 Data Dictionary .............................................34
     Interpreted Mode.....................................................34
                                     - Page 3 -


                                  TABLE OF CONTENTS


     Basic Installation...................................................35
      Main Module ........................................................35
       Initializing Variables ............................................35
       PROCEDURE CTR .....................................................38
       Main Menu Loop ....................................................38
       PROCEDURE WINDOW ..................................................39
       PROCEDURE GET .....................................................40
       FUNCTION YESNO ....................................................41
       Other Main Module Code ............................................41
      SCRPROC.PRG ........................................................42
       PROCEDURE EDIT ....................................................42
         FUNCTION BRV ....................................................42
         FUNCTION BRW ....................................................43
         PROCEDURE FLD_BRO ...............................................43
         PROCEDURE FLD_DES() .............................................43
         PROCEDURE FLD_FND ...............................................43
         PROCEDURE FLD_GET ...............................................44
         PROCEDURE FLD_POP ...............................................44
         PROCEDURE FLD_SAY ...............................................44
         PROCEDURE FLD_SHW ...............................................45
         PROCEDURE FLD_TXT ...............................................45
         PROCEDURE FLD_UNQ() .............................................45
         PROCEDURE FLD_UQS() .............................................45
       PROCEDURE OPTION ..................................................46
         PROCEDURE OPT_GET ...............................................46
         PROCEDURE OPT_SAY ...............................................46
         PROCEDURE OPT_TXT ...............................................46
      Invoking the BROWSE procedure ......................................47
      Invoking the EDIT procedure ........................................47
       Initial Variable values ...........................................47
         Multiple Indices ................................................48
         Customized BROWSE ...............................................48
       Executing EDIT ....................................................48
      Invoking the OPTION procedure ......................................50
       Initial Variable values ...........................................50
       Executing OPTION ..................................................51
     Advanced Installation................................................52
      Installing a header editor .........................................52
      Multiple Screens ...................................................56
      Multi-User Considerations ..........................................58
     Final Word...........................................................60
      Generating Hard-Wire Code ..........................................60
       Creating a project ................................................60
         FORM = -1 .......................................................61
      Distribution .......................................................61
      Conclusion .........................................................61
     Appendices...........................................................62
      Appendix A/ Data Files .............................................62
      Appendix B/ Robert Pope's Expression Builder .......................63
      Appendix C/ GENERIC.PRG ............................................65
     Glossary.............................................................66
     Index................................................................70

                                     - Page 4 -


                            Defining the Data Dictionary


     The first section of this manual will describe the data dictionary
     layout.  Whether you are maintaining an existing SCR.DBF driven
     application, or creating a new one, you will need to get familiar with
     the data dictionary.

     The second section will define the basic installation code necessary to
     use the data dictionary.  The third section describes more advanced
     installation topics.  Unless you're recoding an existing SCR.DBF driven
     application, or creating a new one, you may want to skip these sections.

     The final section describes how to use Hard Wire Four to generate code
     from the data dictionary.  Oh, there is an appendix describing Robert
     Pope's expression builder (sometimes called a query maker).  How to
     install and use his expression builder.

     It is assumed you're familiar with dMAIL4.  You may have noticed, for
     example, that the mailing list editor is very similar to the state id
     editor.  You may have also noticed that each of the mailing list reports
     use the same option grid found in the export/import utilities.

     What you may not realize is that all the screen editors are executed
     from a common procedure.  All option grids are also executed from a
     common procedure.  These procedures depend on the information stored in
     the data dictionary to accomplish their tasks.

     Before we can explain the data dictionary, we must first describe the
     various parts of dMAIL4.


                                 Defining dMAIL4


     dMAIL4 is a simple two flat file system.  The following describes the
     dMAIL4 file structures:

     Structure for database: MAIL.DBF
     Field  Field Name  Type       Width    Dec    Index  Collate
         1  ATTN        Character     30
         2  FIRST       Character     30
         3  LAST        Character     30            Asc   Machine
         4  ADDR_1      Character     30
         5  ADDR_2      Character     30
         6  CITY        Character     20
         7  STATE       Character      2            Asc   Machine
         8  ZIP         Character     20            Asc   Machine
         9  HOME        Character     14
        10  WORK        Character     14
        11  EMAIL       Character     30
        12  BIRTH       Date           8
        13  USER_DATE   Date           8
        14  ACT_DATE    Date           8
        15  MESS        Memo          10
        16  BOL_1       Logical        1
                                     - Page 5 -


                            Defining the Data Dictionary


        17  BOL_2       Logical        1
        18  BOL_3       Logical        1
        19  SADDR_1     Character     30
        20  SADDR_2     Character     30
        21  SCITY       Character     20
        22  SSTATE      Character      2
        23  SZIP        Character     20            Asc   Machine
        24  TEMP1       Logical        1
        25  ALTER       Character      1
     ** Total **                     392

     Structure for database: STATE.DBF

     Field  Name  Type       Width    Dec
         1  STATE       Character      2
         2  STATES      Character     20
         3  ALTER       Character      1
     ** Total **                      23


     The mailing list contains typical information.  First name, last name,
     address, phone, etc.  We also have special purpose fields.  If you are
     curious about their use, read the dMAIL4 user manual.

     In a SCR.DBF driven application, all multi-user databases need a one
     character ALTER field to insure data integrity.  This field will be
     explained in more detail in the advanced installation section.

     Each DBF file will have a structural compound index.  Each compound
     index will contain one or more index tags.  For example, MAIL.DBF has a
     compound index called MAIL.CDX.  MAIL.CDX, for example, has one tag by
     last name, another tag by zip code (used for bulk mailing).  As you can
     guess, STATE.DBF has a compound index called STATE.CDX that has a tag by
     the two character state code.



















                                     - Page 6 -


                            Defining the Data Dictionary


     We will be using the following input layouts:

      012345678901234567890123456789012345678901234567890123456789
      0 First Name:
      1 Last  Name:
      2            Billing                    Shipping
      3 Address 1 :
      4 Address 2 :
      5 City/State:
      6 Zip       :
      7 Attention :
      8 Home      :                           Birth  :
      9 Work      :                           Wedding:
     10 E-Mail    :                           Active :
     11                   +---------- Messages ----------+
     12     [ ] MS-DOS    |                              |
     13     [ ] CP/M      |                              |
     14     [ ] TRSDOS    |                              |
     15                   +------------------------------+


     012345678901234567890123456789012345678901234567890123456789
     1 State      :
     2 Description:

     These are window layouts, not screen layouts.  If you are going to use
     Foxpro, you better get used to windows.

     In a window layout, all positions are relative to the currently defined
     window.  You may use any position, including row 0.  However, the
     various procedures, including EDIT and OPTION, will use the last row for
     messages.


                       Defining the Data Dictionary Layout


     The data dictionary file is called SCR.DBF.  SCR stands for screen
     database, since it's main purpose is to define screen layouts.  SCR.DBF
     has a compound index, SCR.CDX which has index tag by FORM.  The
     following is the data dictionary layout:


     Structure for database: SCR.DBF
     Field  Field Name  Type       Width    Dec    Index  Collate
         1  FORM        Numeric        2            Asc   Machine
         2  SAY_ROW     Numeric        2
         3  SAY_COL     Numeric        2
         4  SAY_TXT     Character     40
         5  SAY_PIC     Character     40
         6  SAY_FUNC    Character     40
         7  SAY_COLOR   Character     40
         8  GET_ROW     Numeric        2
                                     - Page 7 -


                            Defining the Data Dictionary


         9  GET_COL     Numeric        2
        10  GET_NAME    Character     12
        11  GET_READ    Character     40
        12  GET_PIC     Character     40
        13  GET_FUNC    Character     40
        14  GET_RANGE   Character     40
        15  SIZE_1      Numeric        2
        16  SIZE_2      Numeric        2
        17  SIZE_3      Numeric        2
        18  GET_VALID   Character     40
        19  GET_BROWSE  Character     40
        20  GET_ERR     Character     40
        21  GET_COLOR   Character     40
        22  GET_WHEN    Character     40
        23  GET_REST    Character     40
        24  GET_DEF     Character     40
        25  GET_MSG     Character     40
        26  GET_MSG2    Character     40
        27  GET_MEMO    Memo          10
        28  GET_POPUP   Memo          10
        29  GET_DESC    Character     40
     ** Total **                     719


     Note:  If you do not have a copy of SCR.DBF from dMAIL4, you can use
     SCRDBFS.PRG to create one.



























                                     - Page 8 -


                            Defining the Data Dictionary


                             Defining the form number


     In the data dictionary, there are three types of form input.  The full
     screen form, the [F]ind key form, and the option grid form.

     In a full screen type, you define all the input fields required to
     add/update a database record.  The full screen form defines both a full
     screen edit window and a full screen [B]rowse window.

     On a [F]ind type, you define all the input fields required to perform a
     search on the current index tag.  The [F]ind type is not only used to in
     searches, but defines multi-key uniqueness.

     The option grid type defines all the input fields for a group of memory
     variables.  It allows the user to narrow the selection of records and is
     generally used for reports.

     The data dictionary requires each type of input be defined by a form
     number.  Our dMAIL4 system will need 5 form numbers with the following
     functions:


     Form 1  -  All input fields needed to [F]ind by the Last name
     Form 2  -  All input fields needed to [F]ind by the Billing zip code
     Form 3  -  All input fields needed to [F]ind by the Shipping zip code
     Form 4  -  All input fields needed to [F]ind by the State ID, Last name
     Form 5  -  All Mailing list database full screen input fields
     Form 6  -  All input fields needed to [F]ind by the State ID
     Form 7  -  All State database full screen input fields
     Form 15 -  All Mailing list database input fields for an option grid


     The first four forms defines the mailing list indices.  Form 5 defines
     the mailing list database itself.  Form 15 defines the option grid for
     the mailing list database and is very similar to form 5.

     Forms 6 & 7 defines the index key and full screen forms for the state
     database.














                                     - Page 9 -


                            Defining the Data Dictionary


     A form is located using the form number index.  However, the given set
     of records of a form must be in physical order.  Order is very
     important.  Physical order determines which input fields will prompt
     first, next, and last.

     In other words, when you want to add records to the data dictionary,
     don't use APPEND.  Instead, DELETE TAG ALL to delete the data dictionary
     CDX file, then use INSERT BLANK BEFORE.  Don't worry about rebuilding
     the CDX index, since it will get rebuilt on-the-fly.  Oh, and don't
     leave deleted records in the data dictionary.  Remove them with PACK.


                          Defining the Full Screen Form


                           Defining a field description


     For the initial screen layout, we can display text, boxes, panels, or
     any kind of field description.  SAY_ROW, SAY_COL defines the location,
     and SAY_TXT define the actual text.  Any text must be within quotes.  If
     SAY_ROW and SAY_COL are zero, no description is displayed.

     SAY_PIC is used to define the picture format.  All picture formats must
     be within quotes.  SAY_FUNC is used to define the function format.
     SAY_COLOR is used to define the output colors.  The following is an
     example:


          SAY_ROW   [1             ]
          SAY_COL   [1             ]
          SAY_TXT   ["Telephone: " ]
          SAY_COLOR [GB+/N,N/GB+   ]


     This will translate to:

          @ 1,1 SAY "Telephone: " COLOR GB+/N,N/GB+


     If SAY_TXT contains FILL (outside any quotes), the fields GET_ROW and
     GET_COL will get used as the third and fourth output parameters.


     Example:  @ SAY_ROW,SAY_COL FILL TO GET_ROW,GET_COL COLOR GB+/N


     If SAY_TXT contains a TO (outside any quotes), the fields GET_ROW and
     GET_COL also get used as the third and fourth output parameters.


     Example:  @ SAY_ROW,SAY_COL TO GET_ROW,GET_COL COLOR GB+/N

                                     - Page 10 -


                            Defining the Data Dictionary



     Note:  If SAY_TXT contains a DOUBLE or PANEL (outside any quotes)  the
     SAY_TXT is considered a variation of the TO parameter.


     One last option.  The TO, DOUBLE, or PANEL parameters may be preceded by
     text indicating a title.  The following is an example:


          SAY_ROW   [10                      ]
          SAY_COL   [10                      ]
          SAY_TXT   [" Warning  " DOUBLE     ]
          SAY_COLOR [SCHEME 5                ]
          GET_ROW   [20                      ]
          GET_COL   [20                      ]


     This will translate to:


          @ 10,10 TO 20,20 DOUBLE COLOR SCHEME 5
          @ 10,15 SAY " Warning " COLOR SCHEME 5


     A couple of notes:  First, all SAY_TXT fields are displayed once.  That
     is, upon entry into the full screen editor.  This text, therefore, will
     not change from record to record.

     Second, SAY_TXT may contain variables, UDFs, or may be variable length
     only if:  GET_COL and GET_ROW are not zero, or GET_NAME is blank.  If
     GET_COL and GET_ROW are zero, and GET_NAME exists, SAY_TXT must be
     evaluated when hard-wire code is generated (a necessity for mouse
     control).


                            Defining a database field


     For each database field, we can define how it will be displayed and how
     it is to receive input.  GET_ROW and GET_COL define where the field will
     be displayed.  GET_NAME defines the database field itself.  If GET_COL
     and GET_ROW are zero, SAY_ROW and SAY_COL+LEN(&SAY_TXT) will be used.
     If the resulting GET_ROW and GET_COL are zero, or if there is no
     GET_NAME defined, the input field is not displayed.

     GET_PIC is used to define the picture format (both input and output).
     All picture formats must be within quotes.  GET_FUNC is used to define
     the function format.  GET_COLOR is used to define the input colors.  The
     following is an example:




                                     - Page 11 -


                            Defining the Data Dictionary


          SAY_ROW   [1             ]
          SAY_COL   [1             ]
          SAY_TXT   ["Telephone: " ]
          GET_ROW   [0                                 ]
          GET_COL   [0                                 ]
          GET_NAME  [HOME                              ]
          GET_PIC   ["(999) 999-9999"                  ]
          GET_COLOR [GB+/N,N/GB+                       ]


     This will translate to:


          @ 1,12 GET M->HOME PICTURE "(999) 999-9999" COLOR GR+/B,B/GR+


     This statement applies both on input and on displaying the record.  If,
     however, GET_COLOR is defined as:


          GET_COLOR [GB+/N,N/GB+   SAY  GR+/B,B/GR+    ]


     GET_COLOR has a SAY clause.  During a READ, the above example will
     translate to:


          @ 1,12 GET M->HOME PICTURE "(999) 999-9999" COLOR GB+/N,N/GB+


     But during a display (CLEAR GETS), it will translate to:


          @ 1,12 GET M->HOME PICTURE "(999) 999-9999" COLOR GR+/B,B/GR+


     Note:  GET_NAME can now be used to display calculated values.  For
     details, see calculated fields later in this section.


                                   Size Fields


     In Foxpro for Windows, changing fonts can change the way a field is
     displayed. To ensure that the entire input field gets displayed, use the
     SIZE_1, and SIZE_2 to define row height, and column length.  Having both
     field defined will cause Foxpro for Windows to adjust the field,
     regardless of font.

     Typically, SIZE_1 would be defined as 1.  SIZE_2, however, can be
     defined as either the field length, -1, or -2.  A value -1 means to use
     the TXTWIDTH() value of the field itself.  A value of -2 means to use
     the TXTWIDTH() value of the GET_PIC.
                                     - Page 12 -


                            Defining the Data Dictionary



     Note:  You can also specify SIZE_3, which determines the number of
     characters in the memory variables to edit.  Typically SIZE_3 is used
     with an @ EDIT.


                             Defining an @ EDIT field


     IF GET_PIC contains the word "EDIT", and the fields SIZE_1 and SIZE_2
     have value (SIZE_3 is optional), @ GET is converted to @ EDIT.  For
     example:


          GET_ROW   [10            ]
          GET_COL   [10            ]
          GET_NAME  [TEXT          ]
          GET_PIC   ["EDIT"        ]
          GET_COLOR [SCHEME 7      ]
          SIZE_1    [5             ]
          SIZE_2    [50            ]

     The above will translate to:


          @ 10,10 EDIT M->TEXT COLOR SCHEME 7 SIZE 5,50


                              Defining a Memo Field


     If GET_PIC contains the word "MEMO", GET_NAME is a memo field.  A memo
     field gets modified as a temporary file via MODIFY FILE.  Memo fields
     allow multi-user editing and a 'discard changes?' escape route.

     The SAY_ROW and SAY_COL is assumed to be the upper left corner of the
     memo window.  GET_ROW and GET_COL may become the lower right corner.  If
     GET_ROW and GET_COL are greater than SAY_ROW and SAY_COL, a memo window
     will always be displayed.

     On the other hand, if GET_ROW and GET_COL are less then SAY_ROW and
     SAY_COL, the memo will be displayed in the upper left corner of the
     screen.  Since the memo field may cover other input fields, it is
     displayed only as needed.  This also goes true if a defined memo window
     does not fit on the screen.

     Note:  The memowidth is defined by the variable nMEMOWIDTH.  nMEMOWIDTH
     is initialized in the startup procedure.





                                     - Page 13 -


                            Defining the Data Dictionary



                           Validating a database field


     The GET_VALID field determines if user input is allowed and the type of
     validation.  No user input can occur if the first character of GET_VALID
     is blank (See the WHEN clause).  You can use any type of validation
     clause, even if it is just ".T.".

     In GET_VALID, you can define a validation function.  Validation
     functions are useful in checking index fields against other databases.
     For example, there is a STATE.DBF database.  This database contains all
     the state ID and descriptions.  The following function is used to check
     the state ID used in dMAIL4:


     *
     PROCEDURE fnSTATE
     *
     *    THIS FUNCTION DISPLAYS A STATE NAME, GIVEN A TWO CHARACTER ID.
     *
     *    PUBLIC:
     *      bDISPLAY  -  FLAG, TO MAKE SURE A FLD_SAY IS NOT OCCURRING
     *      nCOL      -  COLUMN NUMBER
     *      nROW      -  ROW NUMBER
     *
     *    VARIABLES:
     *      bFOUND    -  FLAG, FOUND FLAG
     *      cTEMP     -  TEMPORARY VARIABLE
     *      nDBF      -  SAVED WORK AREA
     *
     PRIVATE bFOUND, cTEMP, nDBF
     IF M->STATE=SPACE(LEN(M->STATE)) .AND. LASTKEY() <> -2
       RETURN .F.
     ENDIF
     STORE SELECT() TO nDBF
     SELECT STATE
     IF LASTKEY() = -2 .AND. bDISPLAY
       IF M->STATE <> STATE
         SET EXACT OFF
         SEEK TRIM(M->STATE)
         SET EXACT ON
         IF RECNO(0) <> 0 .AND. RECNO(0) <= RECCOUNT()
           GO RECNO(0)
         ENDIF
         IF EOF()
           GO TOP
         ENDIF
       ENDIF
       DO WINDOW WITH "BROWSE", " Browse State Database ", .T., ;
         "CLOSE GROW ZOOM SYSTEM"
       ON KEY LABEL ENTER KEYBOARD CHR(23)
       BROWSE FIELDS STATE,STATES NOEDIT NOAPPEND COLOR SCHEME 10
                                     - Page 14 -


                            Defining the Data Dictionary


       ON KEY LABEL ENTER
       DO WINDOW WITH "BROWSE", .F.
       = fnLASTKEY(10)
       STORE STATE TO M->STATE
     ENDIF
     SET EXACT ON
     SEEK M->STATE
     bFOUND=FOUND()
     IF nROW > 0 .OR. nCOL > 0
       IF bFOUND
         @ nROW,nCOL + LEN(M->STATE) + 2 SAY STATES
       ELSE
         @ nROW,nCOL + LEN(M->STATE) + 2 SAY SPACE(LEN(STATES))
         && IF bDISPLAY
         &&   DO ERR WITH "State ID not found"
         && ENDIF
       ENDIF
     ENDIF
     SELECT (nDBF)
     RETURN bFOUND


     As you can see in this example, any validation function will be passed
     certain variables:  Memory variables of the current record, nCOL, nROW,
     and bDISPLAY.

     The variables nCOL and nROW define the current window position.  No
     output should be displayed if nCOL and nROW are zero (as in a browse).

     The variable bDISPLAY is set to true if the record has been displayed
     and user input can occur.  Use bDISPLAY as a safeguard against
     accidental execution of code.

     If the LASTKEY function is -2, the [F3] key was pressed.  In fnSTATE(),
     pressing [F3] displays a BROWSE of the state database.  This function
     could easily be modified to produce an entire STATE editor.

     Note:  Your startup codes needs SET FUNCTION "F3" TO ";".  The semi-
     colon will translate to [Enter].  Pressing [F3] can then terminate the
     READ, and return LASTKEY() = -2 for a GET_VALID function.

     You may have noticed that the state function is prefixed by two lower-
     case characters.  If any GET_VALID has a validation function, and this
     function is prefixed by two lower-case characters, the function will be
     executed during the SAY display as well during a GET (thus the need to
     use bDISPLAY).  Any boolean result is ignored during the display.

     If the given state ID is found in the database, fnSTATE() will return a
     value of true and will display the state description.  If the value is
     false, the message defined in GET_ERR is displayed.  If there is no
     error message, "Not Acceptable Input" will be displayed.  The user will
     be prompted until a correct state is entered or until [Esc] is pressed.

                                     - Page 15 -


                            Defining the Data Dictionary


     Note:  Your UDF can have display it's own error messages (via DO ERR).
     If your function displays an error message (DO ERR will set bERR=.t.),
     the GET_ERR will not be displayed.  In fnSTATE(), for example, see the
     commented DO ERR command.


     Before continuing, I want to make a couple of points concerning
     validation functions:

          1)  Upon executing a validation function, save the current work
     area and/or record pointer.  The current area and/or record pointer must
     be restored upon exit.  Otherwise, you may be modifying a record not
     currently displayed.

         2)  Work with memory variables (example: M->GROSS).  Except for memo
     fields, which are modified as temporary files.  Actual fields, including
     memo fields, do not get modified until completion of an input screen~1.


                                 The WHEN clause


     You should now be seeing a pattern developing.  In essence, any option
     used in @ SAY or @ GET can be defined in our data dictionary.  This
     includes a WHEN.  The GET_WHEN field determines if user input will
     occur.

     Let me clarify the last statement.  The GET_VALID field determines if
     input is allowed.  If allowed, the GET_WHEN field will determine if
     input will occur.  The GET_WHEN may be any boolean expression.  If no
     expression is specified, then the default is '.T.'

     For example, a blank GET_VALID means no input can occur.  If the first
     character of GET_VALID is blank, that is also means no input can occur.
     A GET_VALID can still contain a function, however, and that function
     will still be executed.


     Note:  When the first character of GET_VALID is blank, no input can
     occur.  Therefore, an @ SAY is used instead of an @ GET/CLEAR GETS to
     display a field.  Keep this in mind when you are selecting colors.









                         
     ~1 See the procedure FLD_GET.

                                     - Page 16 -


                            Defining the Data Dictionary


                                The BROWSE clause


     Now all the input clauses are utilized in the edit [B]rowse command.  As
     far as variables are concerned, all memory variables will be maintained.
     Upon entry to a browse, however, the variables nCOL and nROW will be
     zero.  bDISPLAY will be false.  Also, LASTKEY() cannot test for [F1]
     during a browse.

     You may use the GET_BROWSE field to specify special handling of the
     input field.  For example, GET_BROWSE can specify "/8" for a field
     length of eight.  Any browse field option, except ":V=", may be used.
     GET_VALID defines your validation.

     If GET_BROWSE contains the expression "OMIT", then the input field is
     omitted from the browse.  The input field is still included on the full
     screen editor.

     Suppose, howeve, you want to remove (omit) the input field from the full
     screen editor, but NOT the browse?  Well, leave SAY_ROW, SAY_COL and
     SAY_TXT blank so no column header is displayed.  Leave GET_VALID blank,
     so no input can occur.  Now add `:w=.t.' to GET_BROWSE.  Any `:w=' in
     the GET_BROWSE field will override an implicit/explicit when clause,
     thus adding the field to the BROWSE.


                                The Default clause


     When the [A]dd function is invoked, or when you perform a [Ctrl]-[N] in
     a browse, all memory variables are initialized.  The initial values are
     a macro from GET_DEF.  Any memory variable or numeric constant may be
     used.  Any strings in GET_DEF, however, must be in quotes.  If GET_DEF
     is blank, then the memory variable is initialized via SCATTER MEMVAR
     BLANK.

     Note:  If you need to pass calculated values between fields, use
     GET_REST or use a validation function.  GET_DEF only comes into play at
     the beginning of an add function.  As an example, the following
     validation functions pass calculated values between each other:













                                     - Page 17 -


                            Defining the Data Dictionary


     *
     PROCEDURE fnPRICE
     *
     *    THIS FUNCTION RETURNS A MARK-UP FOR THE GIVEN PRICE.
     *
     *    VARIABLES:
     *      bTEMP    -  TEMPORARY VARIABLE
     *
     PRIVATE bTEMP
     STORE .T. TO bTEMP
     M->MARK_UP=0
     IF M->UNIT_COST > 0
       M->MARK_UP=ROUND(100*((M->UNIT_PRICE-M->UNIT_COST)/M->UNIT_COST),2)
     ENDIF
     RETURN bTEMP


     *
     PROCEDURE fnMARK
     *
     *    THIS FUNCTION RETURNS A UNIT PRICE FOR THE GIVEN MARK UP.
     *
     *    VARIABLES:
     *      bTEMP    -  TEMPORARY VARIABLE
     *
     PRIVATE bTEMP
     STORE .F. TO bTEMP
     IF M->MARK_UP >= 0 .AND. M->MARK_UP <= 100
       STORE .T. TO bTEMP
     ENDIF
     IF bTEMP
       M->UNIT_PRICE=0
       IF M->UNIT_COST > 0
       M->UNIT_PRICE=ROUND((M->UNIT_COST*(M->MARK_UP/100))+M->UNIT_COST,6)
         DO FLD_SHW&cFORM_SCR
       ENDIF
     ENDIF
     RETURN bTEMP


     As you can see, every time the unit price changes the mark-up will
     change.  Every time mark-up changes, and unit price is changed and
     redisplayed.

     Note:  FLD_SHW is the full screen form of "SHOW GETS".








                                     - Page 18 -


                            Defining the Data Dictionary


                                The Restore clause


     In the [A]dd, or [U]pdate modes, pressing [Ctrl]-[Home] will perform a
     restore.  A restore will store a macro of GET_REST into the memory
     variable of the current input field.  The "M->" variable is then
     redisplayed.  If GET_REST is blank, pressing [Ctrl]-[Home] recalls the
     current database field of the current record.

     GET_REST allows calculated recalls.  GET_REST, for example, can recall
     the difference between what was received and what shipped.


          MAX(M->ORD_RVD - M->ORD_SHP,0)


     This example allows the user to ship any quantity remaining.

     As stated earlier, the GET_VALID field determines if user input is
     allowed.  If allowed, the GET_WHEN field will determine if input will
     occur.  If user input is not allowed or cannot occur, GET_REST will be
     used like a GET_DEF field.

     For example, when defining the dMAIL4 ACT_DATE field, we will leave
     GET_VALID and GET_WHEN blank, and will define GET_REST as "DATE()".  In
     this way, when a customer record is updated, ACT_DATE will automatically
     receive the current date.

     Normally, initialization will happen during the update mode and before
     the user is prompted for the first input field.  If the first two
     characters of GET_REST are lower-case, however, then initialization will
     occur during the record display and between each input field.

     For instance, say we had a data dictionary record that did a file
     lookup.  Probably using a defined popup.  Having found the correct
     record, we need some initial field values.  GET_DEF only works before
     user input.  GET_REST with lowercase characters, however, will occur
     between each input field.


          GET_NAME       [CUR_RATE           ]
          GET_VALID      [                   ]
          GET_WHEN       [bADD               ]
          GET_REST       [clIENT->CUR_RATE   ]


     In this example, the CUR_RATE will obtain it's value from the CUR_RATE
     field in the client file.  This will happen between each input field,
     but only in the add mode.


     Note:  Some restore capability has been added to the [B]rowse command.
     If GET_REST is defined, pressing [Ctrl]-[Home] will perform the restore.
                                     - Page 19 -


                            Defining the Data Dictionary



     If an input field has a valid UDF, explicit GET_REST (user input is not
     allowed or cannot occur) fields are restored.  Since this is a browse,
     both upper and lower case explicit GET_REST fields are restored.


                                Calculated fields


     Recently, GET_NAME has been given the ability to define a calculated
     field.  For GET_NAME to have a calculated field, GET_DEF, GET_REST, and
     GET_BROWSE must be defined.  Make sure that the first two characters of
     GET_REST are lower-case.  Example:


          GET_ROW        [10                      ]
          GET_COL        [10                      ]
          GET_NAME       [FLAG                    ]
          GET_VALID      [                        ]
          GET_WHEN       [                        ]
          GET_DEF        [" "                     ]
          GET_BROWSE     [=IIF(EMPTY(GIF)," ","*")]
          GET_REST       [iiF(EMPTY(GIF)," ","*") ]


     There is no database field called FLAG.  If the memo field GIF is not
     empty, an asterisk is displayed.


     Warning Note:  Normally, you would reference memory variables.  But
     there is a bug in Foxpro 2.6a.  On a full screen BROWSE, the record-to-
     record WHEN clause is only executed for the first record.  It should be
     executed for every displayed record.  Memory variables don't get
     refreshed and can't be trusted.  So for calculated browse fields, I
     strongly recommend referencing fields directly.


                                The Message clause


     The screen database field, GET_MSG, simply contains the prompt message
     for each input field.  When prompting the user, the prompt message
     allows you to more clearly describe the input field.  The message must
     be a string and it must be in quotes.









                                     - Page 20 -


                            Defining the Data Dictionary


                            The Second Message clause


     If a screen database contains the field, GET_MSG2, a second message is
     displayed for the given input field.  Unlike GET_MSG, however, GET_MSG2
     is displayed from the MESSAGE procedure (calls the DIALOG procedure, but
     sets display to upper left).  Similar to the way popups display a
     message.  Example:

          GET_MSG2       ["Press [F3] for browse","[Esc] to abort"]

     ...converts to:

          DO MESSAGE WITH "Press [F3] for browse","[Esc] to abort"

     ...before the field is active, and:

          DO DIALOG WITH .F.

     ...after the field is terminated.


                               The GET_MEMO clause


     The screen database field, GET_MEMO, contains the memo help text for
     each input field.  When the user presses [F1], the help memo window will
     appear (unless there is no help text, then control is passed directly to
     the GET_VALID function).  When the DOS environment variable DEBUG is set
     to YES, the user may alter help memo contents.


                                 The Popup clause


     Popups have recently been added to the data dictionary.  A popup is
     defined in the GET_POPUP memo field.  The following is an example of a
     popup memo defined for the field CITY:

               "Detroit"      PROMPT    "Detroit"
               "Grand Rapids" PROMPT    "Grand Rapids"
               "Lansing"      PROMPT    "Lansing"

     Each line represents one option in the popup.  The characters after the
     'PROMPT' represent the displayed popup.  The characters before 'PROMPT'
     represent the returned value.

     Once defined in GET_POPUP, a popup can be executed in one of three ways.
     First, when the first character of GET_VALID is blank.  A blank
     GET_VALID means no user input on the field can occur.  The popup is,
     therefore, mandatory.  Second, when the user presses [F2].  Third, when
     validation returns ".F.".

                                     - Page 21 -


                            Defining the Data Dictionary


     A POPUP can define a file name lookup.  For example, the following
     defines a popup to all program files in the dMAIL4 directory:

          PROMPT FILES   "D:\DMAIL4\*.PRG"

     In PROMPT FILES, anything before "PROMPT " is ignored.  Only the
     filename is returned.  Not the directory path.

     A GET_POPUP also can define a lookup to another file.  For example, for
     our state ID field, we would define a popup to the STATE.DBF file:

          STATE->STATE   PROMPT FIELD STATES

     You must have the FIELD clause.  Upon execution, the state file will be
     displayed in the popup.  When a state id is selected, the memory
     variable M->STATE will contain STATE->STATE.

     The PROMPT FIELD may also contain a SKIP FOR clause.  Example:

          STATE->STATE   PROMPT FIELD   STATES SKIP FOR STATE="VI"

     The "SKIP FOR" is a temporary "SET FILTER TO .NOT. ()" statement.

     There can be other statements in the popup memo field.  If 'SEEK ' is
     found, validation will use this definition of SEEK.  This statement
     allows multiple-key lookups, while retaining single field results.

     If 'SCATTER MEMVAR' is found, and if the popup selection changes, a
     SCATTER MEMVAR will be performed on the lookup file.  All memory
     variables in the current record will reflect the values in the lookup
     file.

     The statement 'SCATTER MEMVAR' is a quick way of obtaining field values.
     You may also specify individual fields.  Example:

          M->PAR_LAST = LAST

     Note:  It is important that you specify memory variables using 'M->'.
     This HW4 system does not recognize 'm.' memory variables.


                              The Description clause


     The GET_DESC has also been added to the data dictionary.  Whereas
     GET_ERR is displayed when validation is false, GET_DESC is displayed
     when validation is true.  When validation becomes true, GET_DESC will be
     displayed one character beyond the last position of the current field.

     There is one special case, and it occurs when a popup is defined.  If
     GET_DESC contains the value 'PROMPT()', it means one of two things.


                                     - Page 22 -


                            Defining the Data Dictionary


     First of course, the user wants the selection prompt to be displayed
     after the input field.  If the first two characters of GET_VALID are
     lower-case (even ".t"), the selection prompt will be displayed during a
     display as well as during a READ.

     Second, and most important, 'PROMPT()' means to perform a validation on
     the input field against the popup selections.  Think of 'PROMPT()' as a
     validation UDF, replacing ".t.", within GET_VALID.  As such, you can
     adjust the validation of a popup.  Example:

          GET_VALID [.t. .OR. EMPTY(M->STATE)]

     This statement allows the state id to be validated against the popup
     list, or to remain blank.

     One more thing.  If you want validation to occur, but don't want the
     description actually displayed, then change your GET_DESC to contain
     'LEFT(" "+PROMPT(),1)'.  A long as GET_DESC has the PROMPT() function,
     validation will still occur.

     By using the 'PROMPT FIELD' popup clause, and the 'PROMPT()' description
     clause, the fnSTATE() function is no longer needed.  For simple files,
     PROMPT popups will actually perform faster than a UDF function.

     You could go one step further by typing an entire list of state id and
     descriptions in the GET_POPUP memo field, thus eliminating the need for
     a STATE.DBF file altogether.  As they say, there's more than one way to
     skin a cat.


                               The GET_READ clause


     Each input field executes it's own @ GET/READ.  You need not concern
     yourself with how many nested READs are active.  This feature also
     allows the user to customize the read.  GET_READ may include any READ
     option available in Foxpro.

     For example, if you were using a radio button on the field TYPE, you
     might want to include 'OBJECT M->TYPE' in your GET_READ.  If you wanted
     to do a push button, you might include 'CYCLE' in your GET_READ.

     One note:  In multi-user mode, a 'READ TIMEOUT nTO_READ' is executed
     (nTO_READ is defined in the start-up procedure).  When a timeout occurs,
     the ALTER field is checked.  If you do want to specify your own TIMEOUT,
     however, the GET_READ value will override the nTO_READ value.







                                     - Page 23 -


                            Defining the Data Dictionary



                          Defining the [F]ind Type Form


     The find type form is a little different from the full screen form.
     Although most of the data dictionary is used in the same way, each
     record in a find form defines just one line of a dialog box.


                           Defining a field description


     SAY_TXT define the actual prompt text.  SAY_COL defines the number of
     spaces before SAY_TXT.  SAY_ROW, SAY_PIC, SAY_FUNC, and SAY_COLOR are
     ignored.


                             Defining an input field


     GET_NAME defines the input field name.  GET_PIC defines the picture
     format.  All picture formats must be within quotes.  GET_COL and GET_ROW
     are ignored.

     GET_PIC can be used to define the picture format.  GET_FUNC can be used
     to define the function format.  GET_COLOR is used to define the input
     colors.


                            Validating an input field


     The GET_VALID field determines if user input is allowed.  No user input
     can occur if the first character of GET_VALID is blank (See the WHEN
     clause).  In a find type form, the GET_VALID does not validate.  It is,
     however, executed.  As you will see later, this feature can be very
     useful.~2

     Note:  On a find form, the variables nCOL and nROW are zero.  The
     variable bDISPLAY is set to true only if TYPE("cFORM_SCR")<>"C".  If the
     find form is already used in a full screen editor, you don't want any
     UDF to accidently call up the editor itself!








                         
     ~2 See the procedure FLD_FND.

                                     - Page 24 -


                            Defining the Data Dictionary


                                 The WHEN clause


     The GET_VALID field determines if input is allowed.  If allowed, the
     GET_WHEN field will determine if input will occur.  The GET_WHEN may be
     any boolean expression.  If no expression is specified, then the default
     is '.T.'


                                The Default clause


     The GET_DEF clause is always used for all find type forms.  If GET_DEF
     is blank, then the memory variable is initialized via SCATTER MEMVAR
     BLANK.


                                The Restore clause


     Pressing [Ctrl]-[Home] will perform a restore.  A restore will store a
     macro of GET_REST into the memory variable of the current input field.
     The "M->" variable is then redisplayed.  If GET_REST is blank, pressing
     [Ctrl]-[Home] recalls the current database field of the current record.


                                The Message clause


     The screen database field, GET_MSG, has different functions depending on
     the form type.  If the form type is a full screen input, then GET_MSG
     will contain the prompt message for each input field.  When prompting
     the user, the prompt message allows you to more clearly describe the
     input field.  The message must be a string and it must be in double
     quotes.

     If the form type is a [F]ind, then GET_MSG contains the description on
     how to build an index search string.  For example, say we had a tag
     index on the mailing list database by last name/active date.  The index
     would be created as follows:


     INDEX ON UPPER(LAST)+DTOC(ACT_DATE,1) TAG DATE OF (cDATAPATH+"MAIL")


     A form 10 could be defined as a [F]ind type.  We would have one input
     field prompting for the last name, another input field prompting for the
     active date.  The GET_MSG for last name would contain UPPER(M->LAST).
     For the active date prompt, GET_MSG would contain DTOC(M->ACT_DATE,1).
     The search string then becomes:


     cSEARCH=UPPER(M->LAST)+DTOC(M->ACT_DATE,1)
                                     - Page 25 -


                            Defining the Data Dictionary




     Note:  A double quote in GET_MSG indicates a full screen form.  If you
     need to define strings in a [F]ind form, use single quotes.


                            The Second Message clause


     If a screen database contains the field, GET_MSG2, a second message is
     displayed for the given input field.  GET_MSG2 is displayed from the
     MESSAGE procedure (calls the DIALOG procedure, but sets display to upper
     left).  Similar to the way popups display a message.  Example:

          GET_MSG2       ["Press [F3] for browse","[Esc] to abort"]

     ...converts to:

          DO MESSAGE WITH "Press [F3] for browse","[Esc] to abort"

     ...before the field is active, and:

          DO DIALOG WITH .F.

     ...after the field is terminated.

     Note:  GET_MSG2 is displayed only if bDISPLAY = .t.  If the find form is
     already used in a full screen editor, bDISPLAY will be .f.


                               The GET_MEMO clause


     The screen database field, GET_MEMO, contains the memo help text for
     each input field.  When the user presses [F1], the help memo window will
     appear (provided a GET_VALID function doesn't grab the [F1] first).
     When the DOS environment variable DEBUG is set to YES, the user may
     alter help memo contents.


                                 The Popup clause


     Popups have recently been added to the data dictionary.  A popup is
     defined in the GET_POPUP memo field.  They can be used for a full screen
     form, a [F]ind key form, or the option grid form.

     Each memo text line represents one option in the popup.  The characters
     after the 'PROMPT ' represent the displayed popup.  The characters
     before 'PROMPT ' represent the returned value.



                                     - Page 26 -


                            Defining the Data Dictionary


     Once defined in GET_POPUP, a popup can be executed in one of three ways.
     First, when the first character of GET_VALID is blank.  A blank
     GET_VALID means no user input on the field can occur.  The popup is,
     therefore, mandatory.  Second, when the user presses [F2].  Third, when
     validation returns ".F.".


                               The GET_READ clause


     Each input field executes it's own @ GET/READ.  You need not concern
     yourself with how many nested READs are active.  This feature also
     allows the user to customize the read.  GET_READ may include any READ
     option available in Foxpro.


                          Defining the Option Grid Form


     We have described the full screen, and [F]ind type forms.  Now we will
     describe the option grid form.  The option grid form is very similar to
     the full screen form.  All the same features are available.  The big
     difference is that you are working with memory variables only, not
     database fields converted to memory variables.


                           Defining a field description


     For the initial screen layout, we can display text, boxes, panels, or
     any kind of field description.  SAY_ROW, SAY_COL defines the location,
     and SAY_TXT define the actual text.  Any text must be within quotes.  If
     SAY_ROW and SAY_COL are zero, no description is displayed.

     SAY_PIC can be used to define the picture format.  SAY_FUNC can be used
     to define the function format.  SAY_COLOR is used to define the output
     colors.

     If SAY_TXT contains FILL (outside any quotes), the fields GET_ROW and
     GET_COL will get used as the third and fourth output parameters.

     If SAY_TXT contains a TO (outside any quotes), the fields GET_ROW and
     GET_COL also get used as the third and fourth output parameters.

     Note:  If SAY_TXT contains a DOUBLE or PANEL (outside any quotes)  the
     SAY_TXT is considered a variation of the TO parameter.

     One last option to consider.  The TO, DOUBLE, or PANEL parameters may be
     preceded by text indicating a title.  The following is an example:




                                     - Page 27 -


                            Defining the Data Dictionary


               SAY_ROW   [10                      ]
               SAY_COL   [10                      ]
               SAY_TXT   [" Warning  " DOUBLE     ]
               SAY_COLOR [SCHEME 5                ]
               GET_ROW   [20                      ]
               GET_COL   [20                      ]


     This will translate to:


               @ 10,10 TO 20,20 DOUBLE COLOR SCHEME 5
               @ 10,15 SAY " Warning " COLOR SCHEME 5


                             Defining an input field


     For each input field, we can define where and how it will be displayed.
     GET_ROW and GET_COL define where the field will be displayed.  GET_NAME
     defines the input field itself.

     For the option grid form, memory variables must be defined in GET_NAME.
     A memory variable is either prefixed by a lower-case letter (as in
     "cTEMP"), or by the characters "M->".


     Note:  You must be the same variables in any GET_VALID, GET_DEF or
     GET_REST as defined in GET_NAME.


     GET_PIC defines the picture format (both input and output).  All picture
     formats must be within quotes.  If GET_COL and GET_ROW are zero, SAY_ROW
     and SAY_COL+LEN(&SAY_TXT) will be used.  If the resulting GET_ROW and
     GET_COL are defined as zero, or if there is no GET_NAME defined, the
     input field is not displayed.

     GET_PIC can be used to define the picture format.  GET_FUNC can be used
     to define the function format.  GET_COLOR is used to define the input
     colors.


     Note:  GET_COLOR may have a SAY clause.  A SAY clause means that all
     text before "SAY" define color during a READ.  All text after "SAY"
     define the CLEAR GETS color.


                             Displaying @ EDIT field


     IF GET_PIC contains the word "EDIT", and the fields SIZE_1 and SIZE_2
     have value (SIZE_3 is optional), the @ GET is converted to @ EDIT. This
     is very useful in the option grid.
                                     - Page 28 -


                            Defining the Data Dictionary



     For example, in dMAIL4 there is a memo field called MESS.  In the option
     grid, we can use @ EDIT to define a character string M->MESS.  M->MESS
     will look and feel like a memo window.  M->MESS will allow the user to
     define several wild-cards on the memo MESS (please see MALPR1.PRG).  To
     really look like a memo window, you may need to include a DOUBLE with a
     title.


                              Defining a memo field


     If GET_PIC contains the word "MEMO", GET_NAME is a memo field.  A memo
     field gets modified as a temporary file via MODIFY FILE.  Memo fields
     allow multi-user editing and a 'discard changes?' escape route.

     The SAY_ROW and SAY_COL is assumed to be the upper left corner of the
     memo window.  GET_ROW and GET_COL may become the lower right corner.  If
     GET_ROW and GET_COL are greater than SAY_ROW and SAY_COL, a memo window
     will always be displayed.

     On the other hand, if GET_ROW and GET_COL are less then SAY_ROW and
     SAY_COL, the memo will be displayed in the upper left corner of the
     screen.  Since the memo field may cover other input fields, it is
     displayed only as needed.  This also goes true if a defined memo window
     does not fit on the screen.


                            Validating an input field


     The GET_VALID field determines if user input is allowed and the type of
     validation.  No user input can occur if the first character of GET_VALID
     is blank (See the WHEN clause).  You can use any type of validation
     clause, even if it is just ".T.".

     For validation functions, certain variables are passed.  The variables
     nCOL and nROW define the current window position.  No output should be
     displayed if nCOL and nROW are zero.

     The variable bDISPLAY is set to true if the record has been displayed
     and user input can occur.  Use bDISPLAY as a safeguard against
     accidental execution of code.

     If any GET_VALID has a validation function, and this function is
     prefixed by two lower-case characters, the function will be executed
     during the display as well during a GET.  Any boolean result is ignored
     during the display.

     If the validation is false, the message defined in GET_ERR is displayed.
     If there is no error message, "Not Acceptable Input" will be displayed.
     The user will then be prompted until a correct state is entered or until
     [Esc] is pressed.
                                     - Page 29 -


                            Defining the Data Dictionary




                                 The WHEN clause


     The GET_VALID field determines if input is allowed.  If allowed, the
     GET_WHEN field will determine if input will occur.  The GET_WHEN may be
     any boolean expression.  If no expression is specified, then the default
     is '.T.'

     For example, a blank GET_VALID means no input can occur.  If the first
     character of GET_VALID is blank, that is also means no input can occur.
     A GET_VALID can still contain a function, however, and that function
     will still be executed.

     Note:  When the first character of GET_VALID is blank no input can
     occur.  Therefore, an @ SAY is used instead of an @ GET/CLEAR GETS to
     display a field.  Keep this in mind when you are selecting colors.


                                The Default clause


     Default values may either be defined outside the option grid, or using
     the GET_DEF field.  Any memory variable or numeric constant may be used
     in GET_DEF.  Any strings, however, must be in quotes.


                                The Restore clause


     In the [U]pdate mode, pressing [Ctrl]-[Home] will perform a restore.  A
     restore will store a macro of GET_REST into the GET_NAME variable of the
     current input field.

     In a full screen form, [Ctrl]-[Home] recalls the current database field
     of the current record.  In an option grid, however, the initial values
     of variables are stored in an array call OPT.

     If GET_REST is blank, therefore, the value saved in OPT(nFLD) is
     recalled (Where nFLD indicates the current field location).


                                The Message clause


     The screen database field, GET_MSG, simply contains the prompt message
     for each input field.  When prompting the user, the prompt message
     allows you to more clearly describe the input field.  The message must
     be a string and it must be in quotes.



                                     - Page 30 -


                            Defining the Data Dictionary


                            The Second Message clause


     If a screen database contains the field, GET_MSG2, a second message is
     displayed for the given input field.  Unlike GET_MSG, however, GET_MSG2
     is displayed from the DIALOG procedure.  Similar to the way popups
     display a message.


                               The GET_MEMO clause


     The screen database field, GET_MEMO, contains the memo help text for
     each input field.  When the user presses [F1], the help memo window will
     appear (unless there is no help text, then control is passed directly to
     the GET_VALID function).  When the DOS environment variable DEBUG is set
     to YES, the user may alter help memo contents.


                                 The Popup clause


     Popups have recently been added to the data dictionary.  A popup is
     defined in the GET_POPUP memo field.

     Each line represents one option in the popup.  The characters after the
     'PROMPT' represent the displayed popup.  The characters before 'PROMPT'
     represent the returned value.

     Once defined in GET_POPUP, a popup can be executed in one of three ways.
     First, when the first character of GET_VALID is blank.  A blank
     GET_VALID means no user input on the field can occur.  The popup is,
     therefore, mandatory.  Second, when the user presses [F2].  Third, when
     validation returns ".F.".

     A POPUP can define a file name lookup.  For example, the following
     defines a popup to all program files in the dMAIL4 directory:

          PROMPT FILES   "D:\DMAIL4\*.PRG"

     In PROMPT FILES, anything before "PROMPT " is ignored.  Only the
     filename is returned.  Not the directory path.

     A POPUP also can define a lookup to another file.  For example, the
     following defines a popup to the field STATE:

          STATE->STATE   PROMPT FIELD   STATES

     You must have the FIELD clause.  Upon execution, the state descriptions
     will be displayed in the popup.  When a state is selected, the memory
     variable M->STATE will contain STATE->STATE.

     The PROMPT FIELD may also contain a SKIP FOR clause.  Example:
                                     - Page 31 -


                            Defining the Data Dictionary



     STATE->STATE   PROMPT FIELD   STATE SKIP FOR STATE="MI"

     The "SKIP FOR" is a temporary "SET FILTER TO .NOT. ()" statement.


                              The Description clause


     The GET_DESC field was recently added to the data dictionary.  Where
     GET_ERR is displayed when validation is false, GET_DESC is displayed
     when validation is true.  When validation becomes true, GET_DESC will be
     displayed one character beyond the last position of the current field.

     There is one special case, and it occurs when a popup is defined.  If
     GET_DESC contains the value 'PROMPT()', it means one of two things.

     First, of course, the user wants the selection prompt to be displayed
     after the input field.  If the first two characters of GET_VALID are
     lower-case (even ".t"), the selection prompt will be displayed during a
     display as well as during a READ.

     Second, and most important, 'PROMPT()' means to perform a validation on
     the input field against the popup selections.  Think of 'PROMPT()' as a
     validation UDF, replacing ".t.", within GET_VALID.  As such, you can
     adjust the validation of a popup.  Example:

          GET_VALID [.t. .OR. EMPTY(M->STATE)]

     In the option grid, this statement allows the state id to remain blank
     (something you need in an option grid).  Otherwise, it is validated
     against the state database.  If you want validation to occur, but don't
     want the description actually displayed, then change your GET_DESC to
     contain 'LEFT(" "+PROMPT(),1)'.  A long as GET_DESC has a PROMPT(),
     validation will still occur.


                               The GET_READ clause


     Each input field executes it's own @ GET/READ.  You need not concern
     yourself with how many nested READs are active.  This feature also
     allows the user to customize the read.  GET_READ may include any READ
     option available in Foxpro.

     For example, if you were using a radio button on the numeric field
     nTYPE, you might want to include 'OBJECT nTYPE' in your GET_READ.  If
     you wanted to perform a push button, you might include 'CYCLE' in your
     GET_READ.




                                     - Page 32 -


                            Defining the Data Dictionary


     One note:  In multi-user mode, a 'READ TIMEOUT nTO_READ' is performed
     (nTO_READ is defined in the start-up procedure).  When a timeout occurs,
     the ALTER field is checked for change.  If you do want to specify your
     own TIMEOUT, however, the GET_READ value will override the nTO_READ
     value.
















































                                     - Page 33 -


                            Defining the Data Dictionary



                              dMAIL4 Data Dictionary


     Well, now that you have been shown all the fundamentals of a data
     dictionary.  When creating your own data dictionary, there is only a
     couple of points to remember:


          1)  SAY_TXT, GET_PIC, GET_DEF, and GET_MSG (for full screen input)
     have to be in string format.  All strings should be surrounded by
     quotes.

          2)  In a full screen form, database fields (outside of GET_NAME)
     should be referenced by it's memory variable counter-part.  Never
     reference a database field directly.  Only when a full screen input is
     completed does database fields get replaced by their memory variables.


     Yes, using the data dictionary can be complicated.  There's a lot of
     interaction between the data dictionary fields.  Yet, it is this very
     interaction that gives you so much power and flexibility.

     My advice is to browse through the dMAIL4 SCR.DBF data dictionary.
     Compare the fields of each record with the documentation you just read.
     Then run dMAIL4.  You'll find that every record defined is doing exactly
     what it should in the application.


                                 Interpreted Mode


     If you want to start modifying the dMAIL4 SCR.DBF right away, first
     remove the files SCR.PRG and SCR.FXP.  This will put the application
     into interpreted mode.  After you've made changes, you can use Hard Wire
     Four to generate new SCR.PRG and SCR.FXP files (see the final section on
     generating code).
















                                     - Page 34 -


                                 Basic Installation


     The first section described how to work with the SCR.DBF data
     dictionary.  The next two sections will describe how to create an
     application using this data dictionary.  If you're just maintaining an
     existing data dictionary, you may want to skip these sections.

     I always found the best way to create a SCR.DBF driven application is to
     reuse an existing one.  dMAIL4 is a good starting point.  Say I wanted
     to create an invoicing application.  I'd start off with a "INV\"
     directory.  I'd copy all my dMAIL4 files into this directory, renaming
     all MAL*.* files to INV*.* files.  I'd modify the code, changing all
     occurrences of "MAL" to "INV".  To add a customer file, for example, I
     might change MAIL.* files to CUST.* files and all code references of
     "MAIL" to "CUST".


                                   Main Module


     For those who need to create a SCR.DBF driven application from scratch,
     the first thing you need is a copy of the procedure file SCRPROC.PRG.
     This procedure file is the basic framework for your application.  To use
     this framework, you need to initialize some variables and system
     environment settings in your startup or main module.


                              Initializing Variables


     In the dMAIL4 main module called MAL.PRG, the following code is used to
     initialize variables:


     cPATH_SEP = "\"
     cDRIV_SEP = ":\"
     IF _UNIX
       cPATH_SEP = "/"
       cDRIV_SEP = "/"
     ENDIF


     Note:  These variables define your system's data and drive path
     separators and are used in procedures that manipulate directories.


     STORE FULLPATH(SYS(2005)) TO cMEMPATH
     IF EMPTY(SYS(2005))  && Foxpro for DOS bug
       STORE FULLPATH(SYS(2019)) TO cMEMPATH
     ENDIF
     STORE SUBSTR(cMEMPATH,1,RAT(cPATH_SEP,cMEMPATH)) TO cMEMPATH
     = fnPATH(@cMEMPATH)

     STORE fnGETENV("DATA") TO cDATAPATH
     = fnPATH(@cDATAPATH)
                                     - Page 35 -


                                 Basic Installation



     STORE FULLPATH(fnGETENV("PROG")) TO cPROGPATH
     = fnPATH(@cPROGPATH)

     STORE fnGETENV("TEMP") TO cTEMPPATH
     = fnPATH(@cTEMPPATH)


     Note:  These variables define the user resource, data, program and
     temporary file paths.  Noticed we use two functions, fnGETENV and
     fnPATH.  fnGETENV will get environment variables from the [GetEnv]
     section of your FOXPRO.INI (found in the user resource directory
     cMEMPATH).

     fnPATH returns an empty string on an invalid path.  Since both these
     functions help determine your program path, they must to stored be in
     your application startup module, not your SCRPROC.PRG procedure file.
     See the dMAIL4 main module MAL.PRG for the actual code.


     IF UPPER(fnGETENV("MULT")) = "NO"
       SET EXCLUSIVE ON
       SET REFRESH TO 0
       STORE .F. TO bMULT
     ELSE
       SET EXCLUSIVE OFF
       SET REFRESH TO 0
       STORE 30 TO nREFRESH
       IF VAL(fnGETENV("REFRESH")) > 0
         STORE VAL(fnGETENV("REFRESH")) TO nREFRESH
       ENDIF
       STORE .T. TO bMULT
     ENDIF

     IF LEN(fnGETENV("DEBUG"))>0 .AND. .NOT. "RUNTIME" $ UPPER(VERSION());
                               .AND. .NOT. "EXE"     $ UPPER(VERSION())
       STORE .T. TO bDEBUG
       SET DEBUG ON
       SET DEVELOPMENT ON
       SET HELP ON
     ELSE
       STORE .F. TO bDEBUG
       SET DEBUG OFF
       SET DEVELOPMENT OFF
       SET ECHO OFF
       SET HELP OFF
       SET STEP OFF
     ENDIF

     bANSI = _DOS .OR. _MAC .OR. _WINDOWS .OR. "ANSI" $
     UPPER(fnGETENV("TERM"))

     bINIT   = LEN(fnGETENV("INIT")) > 0
                                     - Page 36 -


                                 Basic Installation


     bRECALL = LEN(fnGETENV("RECALL")) > 0


     Note:  This code defines some of the basic system flags needed.  They
     also use the fnGETENV function.  For example, bMULT indicates multi-user
     enabled.  bINIT indicates a system administration enabled.  Check the
     glossay for details.


     DIMENSION cWINDOW(1),nWINDOW(1)
     STORE "" TO cWINDOW
     STORE  0 TO nLEVEL, nWINDOW
     STORE  4 TO nSTART

     STORE .F. TO bLOCATE, bNO_CDX, bNO_ERR
     STORE .F. TO bBLK, bEXACT, bINT, bINV, bNO_INT, bUNIQUE
     STORE ""  TO cFONT, cSTYLE
     STORE 60  TO nMEMOWIDTH
     STORE  0  TO nFONT, nSCHEME

     STORE 600 TO nTO_READ

     STORE    "" TO cBROWSE, cINDEX
     STORE ".T." TO cFILTER


     Note:  These variables are needed in the edit and option grid
     procedures.  For information on variable usage, check the Glossary.


     SET FUNCTION "F3" TO ";"
     SET MEMOWIDTH TO nMEMOWIDTH
     SET PATH TO (cPROGPATH)
     SET PROCEDURE TO SCRPROC


     Note:  These are some of the more important environment settings.  See
     MAL.PRG for a complete listing.


     STORE "MAL"    TO cMASTER ~1
     STORE "MALEDA" TO cREINDEX ~2
     STORE "MALSYS" TO cSYSTEM ~3
                         
     ~1 Startup procedure file.  When an error is logged into the Foxpro
     error handler, program control is returned to this procedure.

     ~2 Procedure defined to reindex all database files.  Used in error
     handler.

     ~3 System memory file.  Used to store printer codes and other system
     variables.

                                     - Page 37 -


                                 Basic Installation




     Note:  The variables are used by the error handler in SCRPROC.PRG.


                                  PROCEDURE CTR


     The CTR procedure is quite handy for displaying column centered messages
     on the screen.  The following code, for example, displays the dMAIL4
     application header on rows 1 & 2:


     ACTIVATE SCREEN
     DO CTR WITH 1, IIF(bMULT,"Multi-user ","")+"Mailing List, Ver 04.00.00"
     DO CTR WITH 2, "(c) 1987-1998 Dennis Allen, All rights reserved"


     Note:  We could have prefixed each CTR command with "bINT=.T." to make
     the message intense (bold), or "bINV=.T." to inverse the colors.


                                  Main Menu Loop


     I recommend using the following code within your main menu loop:


       POP KEY ALL
       ON ERROR DO FOXERR WITH ERROR(), MESSAGE(), MESSAGE(1), PROGRAM(),
     LINENO(), SYS(16)
       IF bANSI
         IF _DOS
           ON KEY LABEL INS DO INS
         ENDIF
         ON KEY LABEL ALT+O DO OBJLOCK
         ON KEY LABEL ALT+V DO VIDEO
         ON KEY LABEL F1    DO FLD_HELP WITH
     IIF(nLEVEL>0,cWINDOW(nLEVEL),""), 0
         ON KEY LABEL F7    DO EJECT
         ON KEY LABEL F10   KEYBOARD CHR(23)
         IF bDEBUG
           ON KEY LABEL ALT+D DO DEBUGGER WITH PROGRAM(), LINENO()
         ENDIF
         ON KEY LABEL ALT+F4 DO LOAD_CALC
         ON KEY LABEL CTRL+F4 DO SET_CALC
         ON KEY LABEL ALT+F5 DO LOAD_CALR
         ON KEY LABEL CTRL+F5 DO SET_CALR





                                     - Page 38 -


                                 Basic Installation


       ENDIF
       SET DELETED ON
       SET ESCAPE OFF
       SET EXACT ON
       SET UDFPARMS TO VALUE
       CLEAR GETS
       CLEAR MENUS
       CLEAR POPUPS
       CLEAR PROMPT
       CLEAR TYPEAHEAD
       CLEAR WINDOWS
       CLOSE MEMO ALL
       FLUSH
       RELEASE _DIALOG, _THERM

       DO SET_VIEW

       STORE 0 TO nLEVEL

       STORE .F. TO bLOCATE, bNO_CDX, bNO_ERR
       STORE .F. TO bBLK, bEXACT, bINT, bINV, bNO_INT, bUNIQUE
       STORE "" TO cFONT, cSTYLE
       STORE  0  TO nFONT, nSCHEME

       STORE    "" TO cBROWSE, cINDEX
       STORE ".T." TO cFILTER


     Note:  This code is designed to reset the system after a "[Q]uit to main
     menu" from the error handler in SCRPROC.PRG.


                                 PROCEDURE WINDOW


     The SCRPROC.PRG procedure file has a many routines to help you create an
     application.  For example, each menu should have it's own window.  So
     add the following code to your main menu loop:

       DO WINDOW WITH "MAL", " M A I N   M E N U "


     This command defines the window "MAL" with a title "M A I N   M E N U".

     The starting row was defined by the variable nSTART.  The default to
     nSTART is usually 4, so that the application header does not get
     covered.

     The starting column is determined by the value of MOD(nLEVEL,4).  This
     gives your windows a layered effect.  FYI:  nLEVEL is the current window
     level.  cWINDOW(nLEVEL) is the name of the current window.

     The WINDOW procedure is quite powerful.  For example, the following:
                                     - Page 39 -


                                 Basic Installation



     nSTART=1
     DO WINDOW WITH "TEMP", " TEMP WINDOW ", .T., "GROW FLOAT"

     This command defines a full screen window that can grow or float.
     nLEVEL is ignored.  To remove this window, execute the following:

     DO WINDOW WITH "TEMP", .F.


     Note:  If you perform a 'CLEAR WINDOW' and a 'STORE 0 TO nLEVEL' in your
     menu loop, you don't need to add a 'DO WINDOW WITH "", .F.'.


                                  PROCEDURE GET


     Your SCRPROC.PRG has a GET procedure.  This procedure provides an easy
     way to create and maintain menus.  In essence, each call to the GET
     procedure creates a single @ GET push-button.

     @ GET push buttons have a couple of advantages over traditional @
     PROMPTs.  First, unlike an @ PROMPT, an @ GET push button allows access
     to the system menu.  Second, within Foxpro for windows (and Macintosh),
     @ GET push buttons do conform to the current font selection.

     The following code creates the main menu for dMAIL4:


       nCOL = ROUND(WCOLS()/2,0) - 19
       DO GET WITH  1,nCOL, "[\<E] - Edit  Mailing List"
       DO GET WITH  3,nCOL, "[\<P] - Print Mailing List"
       DO GET WITH  7,nCOL, "[\<S] - System Setup (Query)"
       DO GET WITH  9,nCOL, "[\<U] - Utilities"
       DO GET WITH 11,nCOL, "[\<M] - Change Status
     ("+IIF(bMULT,"Multi","Single") ;
         +"-user)", UPPER(fnGETENV("MULT")) = "NO" .OR. .NOT. bINIT
     DO GET WITH 13,nCOL, "[\<Q] - Quit this program"
       cCHOICE = fnCHOICE("EPSUMQ", "Q")


     As you can see, you pass GET with the desired row, column, and prompt
     (including hot keys).  In our case, nCOL is the column position,
     adjusted for any size screen.  As you see in option M, you can also
     specify a SKIP FOR clause.

     Once all our push buttons are defined, a simple call to fnCHOICE
     executes the READ and returns the user selection.  If the user presses
     [Esc], fnCHOICE returns the default "Q".




                                     - Page 40 -


                                 Basic Installation


                                  FUNCTION YESNO


     When you wish to quit the menu main loop, you might want to include the
     following code:

       CASE cCHOICE = "Q"
         IF YESNO(" Are you Sure (Y or N) ?  ","N") = "N"
           LOOP
         ENDIF
         EXIT
       ENDCASE


     The YESNO function is a handy way of prompting the user.  In this case,
     it prevents the user from accidently leaving the application.


                              Other Main Module Code


     I haven't explained all the main module's code.  For example, there is
     code to set the fonts for the main screen, code to test for disk
     capacity, code to keep the size of the foxuser file from growing, and
     code to prompt the shareware user to register after 90 days.

     You might see code testing if SET("RESOURCE") is "ON".  I've designed my
     applications so that if RESOURCE is ON, the user may change colors,
     change printer codes, modify expressions in the expression builder,
     change default settings, etc.  RESOURCE that is OFF is like a read-only
     mode.  The user may change printer codes, but these changes are not
     saved.  With this method, you could have many users sharing the same
     network user resource directory.  This design also allows a user to
     launch the same application multiple times.  That is, unless you don't
     want it allowed (see RESTART=NO in configuration manual).

     I store printer control codes as ?PR_* variables.  These variables are
     stored in the user resource directory as a memory file, using the name
     stored in cSYSTEM.

     I also store other information in ?PR_* variables.  Since ?PR_*
     variables are saved in the user resource directory, I find them very
     useful for saving user defaults.  For example, nPR_ROW13, nPR_COL13
     might store the row/column position of the goto window in form 13.

     If you have any questions on how to create a startup module, see the
     dMAIL4 main module MAL.PRG.  For more information on variable usage,
     check the Glossary.

     As time passes, more code might be introduced.  dMAIL4 is not a static
     package.  Again, the best thing to do is to grab the latest copy of a
     SCR.DBF driven application, such as dMAIL4.  Then look at the latest
     code for the latest features.
                                     - Page 41 -


                                 Basic Installation


                                   SCRPROC.PRG


     Now that we examined our main module, it's time we looked at the
     procedure file SCRPROC.PRG more closely.  The following is a brief
     layout of the file SCRPROC.PRG:


          *
          * PROGRAM SCRPROC.PRG
          *
          . (utility functions)
          . (utility procedures)
          *
          PROCEDURE BROWSE
          . (utility functions and procedures used by BROWSE)
          *
          PROCEDURE EDIT
          . (utility functions and procedures used by EDIT)
          *
          PROCEDURE OPTION
          . (utility functions and procedures used by the option grid)
          *
          ON KEY LABEL routines


     Now I'm not about to explain each and every procedure in detail.  You
     can read the source code yourself.  I do, however, want to explain a
     little of the EDIT procedure and a little of the OPTION procedure.


                                  PROCEDURE EDIT


     The EDIT procedure is our "little black box".  It provides all functions
     necessary to create and maintain a given database (Add, Browse, Delete,
     Find, Goto, Help, Update, or Quit).  There is a set of procedures that
     help EDIT perform these functions.  The following is a brief description
     of a few of them:


                                   FUNCTION BRV


     This internal function is executed on a BROWSE.  It is passed one
     parameter.  A value of 0 indicates a record to record VALID.  Any other
     value is the field number (a.k.a. data dictionary record number) to
     execute a field to field VALID function.





                                     - Page 42 -


                                 Basic Installation


                                   FUNCTION BRW


     This internal function is executed on a BROWSE.  It is passed one
     parameter.  A value of 0 indicates a record to record WHEN.  Any other
     value indicates the field number to execute a field to field WHEN
     function.


                                PROCEDURE FLD_BRO


     This procedure initializes and executes the BROWSE.  In multi-user mode,
     a BROWSE TIMEOUT is performed.  If time is out, and the current record
     has not been altered, the BROWSE is once again executed.


     Note:  Do not confuse this procedure with the procedure called BROWSE.
     The procedure called BROWSE allows you to perform a browse by itself,
     independent of the EDIT procedure.


                               PROCEDURE FLD_DES()


     This procedure returns the description defined in GET_DESC.  If
     'PROMPT()' is defined, a validation is performed against the popup in
     GET_POP of the current form.

     Note:  FLD_DES can be used outside of the EDIT procedure.   For example,
     our reports can use the following code to retrieve state descriptions:


     PRIVATEcFORM_SCR, nFORM_SCR
     nFORM_SCR = 13
     M->STATE = "MI"
     ? PROPER(FLD_DES("M->STATE"))


                                PROCEDURE FLD_FND


     This procedure does all input field prompts for the [F]ind type forms.
     Each record will invoke a single line dialogue box.

     Note: The FLD_FND can used independently of the EDIT procedure.  For
     example, the following code will prompt the user for the customer name:






                                     - Page 43 -


                                 Basic Installation


     DO CTR WITH 3, "Press [ENTER] for default of first record"
     SELECT MAIL
     nFORM_NDX=1
     cFORM_NDX=LTRIM(STR(nFORM_NDX)) + ' IN SCR'
     DO FLD_FND&cFORM_NDX
     IF LASTKEY() = 27
       RETURN
     ENDIF


     The FLD_FND is very useful in reports.  For instance, we can include a
     GET_VALID function that allows the user to press [F1] for the mailing
     list editor.  Upon exiting the mailing list editor, the current record
     can then become the [F]ind record.  If a wildcard LOCATE is in effect,
     the variable bLOCATE will return true.

     Note:  The statement 'DO FLD_FND&cFORM_NDX' executes the hard-wired
     procedure found in 'SCR.PRG'.  If 'SCR.PRG' does not exist, the error
     handler will set cFORM_NDX to null.  That way, the interpreter procedure
     FLD_FND will be executed.  So if you hear a beep, you know you are in
     interpreted mode.


                                PROCEDURE FLD_GET


     This procedure does all input field prompts for the Add and Update
     functions.  If add mode is in effect, bADD is set to true.  When a
     screen input is completed, FLD_GET will then perform the appropriate
     APPEND/REPLACE statements to create/update the current record.  If all
     fields are replaced, bSAVED is set to true.


                                PROCEDURE FLD_POP


     This procedure performs the popup for the current record in the screen
     database.  You may pass it the VARREAD() or the RECNO() of the SCR.DBF
     file.  If no parameters is passed, the current record of the SCR.DBF is
     assumed.  If the second parameter is set to true, then FLD_POP is being
     activated for a BROWSE.


                                PROCEDURE FLD_SAY


     This procedure restores all field descriptions to the screen.  It will
     display the values of fields in the current record.  All GET_VALID
     functions are executed.  If all fields were completely displayed,
     bDISPLAY to set to true.



                                     - Page 44 -


                                 Basic Installation


                                PROCEDURE FLD_SHW


     This procedure is equivalent of a SHOW GETS.  It restores all field
     descriptions to the screen.


                                PROCEDURE FLD_TXT


     This procedure initializes all field descriptions to the screen.  It
     also will initialize all mouse cursor locations.


                               PROCEDURE FLD_UNQ()


     This procedure simply determines if an index key is unique.  If bUNIQUE
     was set to true before entering EDIT, the procedure FLD_GET will not let
     the user create a database record with duplicate keys.


                               PROCEDURE FLD_UQS()


     While FLD_UNQ validates one index, FLD_UQS validates all indices defined
     in the cINDEX array.


























                                     - Page 45 -


                                 Basic Installation



                                 PROCEDURE OPTION


     This procedure is a mirror image of the EDIT procedure.  The user has
     similar choices (Continue, Help, Update, or Quit).  Unlike EDIT,
     however, OPTION will return a LASTKEY() of 27 if the user pressed [Q] to
     quit.

     There is a set of procedures that help OPTION perform these functions.
     The following is a brief description of each procedure:


                                PROCEDURE OPT_GET


     This procedure performs all input field prompts for the Update function.
     When a screen input is completed, bSAVED is set to true.


                                PROCEDURE OPT_SAY


     This procedure restores all field descriptions to the screen.  It will
     display the values of all fields in the current record.  All GET_VALID
     functions are executed.  If all fields were completely displayed,
     bDISPLAY to set to true.


                                PROCEDURE OPT_TXT


     This procedure initializes all restore values to the screen.  For the
     option grid, it is the job of FLD_TXT to initialize descriptions and
     mouse cursor locations.


















                                     - Page 46 -


                                 Basic Installation



                          Invoking the BROWSE procedure


     Similar to EDIT procedure, the BROWSE procedure invokes the [B]rowse
     command directly.  The syntax is the same as the EDIT procedure (See the
     EDIT procedure for details).  For example:


     DO WINDOW WITH "", "Browse"
     SELECT MAIL
     nFORM_NDX=1
     nFORM_SCR=3
     bUNIQUE=.F.
     DO BROWSE
     DO WINDOW WITH "", .F.


                           Invoking the EDIT procedure


     Our main module has initialized all DOS environment and system
     variables.  Now we can edit database files.

     A database file can be edited directly from the main menu or from an
     edit menu.  I prefer calling an edit menu.  An edit menu allows you to
     group edit functions, initialize databases, set index orders and reset
     databases filters.  An edit menu also allows you to hide system
     administrator functions, such as reindexing and zapping.

     To invoke the screen editor, you need to initialize your database in a
     work area.  This work area must have an alias.


                             Initial Variable values


     To invoke the edit procedure, you need to set the following variables:

          nFORM_NDX= # of the [F]ind type form, zero if no index
          nFORM_SCR= # of the full screen/option grid input form

     Set bEXACT to true if the form, defined by nFORM_NDX, demands an exact
     match to any find prompt.

     Set bUNIQUE to true if the form, defined by nFORM_NDX, is a unique
     index.  That is, a record cannot be added or updated until this index
     proves to be unique.





                                     - Page 47 -


                                 Basic Installation


                                 Multiple Indices


     If you have a database file with multiple indices, they can be defined
     in the array cINDEX.  Each row element in cINDEX defines an index.  The
     following is a layout for each index:

          cINDEX(,1)     =    nFORM_NDX number
          cINDEX(,2)     =    TAG name
          cINDEX(,3)     =    bUNIQUE flag
          cINDEX(,4)     =    bEXACT flag
          cINDEX(,5)     =    title used in toggle prompt

     With the above information, multiple unique keys can be validated.  As
     an added bonus, this information allows the user to use the [T]oggle
     index option of the edit procedure.  The following, for example, allows
     the dMAIL4 editor to toggle between the last name and the zip code
     indices:

          DIMENSION cINDEX(2,5)
          STORE "" TO cINDEX
          cINDEX(1,1) = 1
          cINDEX(1,2) = "LAST"
          cINDEX(1,3) = .T.
          cINDEX(1,4) = .F.
          cINDEX(1,5) = "Last Name"

          cINDEX(2,1) = 2
          cINDEX(2,2) = "ZIP"
          cINDEX(2,3) = .F.
          cINDEX(2,4) = .F.
          cINDEX(2,5) = "Zip Code"

     Note:  When using this table, use nFORM_NDX to define the default index
     for the toggle prompt.


                                Customized BROWSE


     If you want to customize your browse, use the variable cBROWSE.  For
     example, if you don't want records added or deleted in the browse
     screen, you would set cBROWSE = "NODELETE NOAPPEND".


                                  Executing EDIT


     Once you defined a screen database, it takes very little code to
     maintain a database.  The following, for example, provides all the code
     needed to maintain the mailing list database:


                                     - Page 48 -


                                 Basic Installation



     DO INITIAL
     DO WINDOW WITH "", "Mailing List Editor:  Indexed by Last Name"
     SELECT MAIL
     nFORM_NDX=1
     nFORM_SCR=3
     bUNIQUE=.T.
     DO EDIT
     DO WINDOW WITH "", .F.


     I usually keep an INITIAL procedure in my main module.  The procedure
     INITIAL will contain the following code:


     IF .NOT. USED("MAIL")
       SELECT 0
       USE (cDATAPATH+"MAIL") INDEX (cDATAPATH+"MAIL") ALIAS MAIL
     ENDIF
     IF .NOT. USED("STATE")
       SELECT 0
       USE (cDATAPATH+"STATE") INDEX (cDATAPATH+"STATE") ALIAS STATE
     ENDIF
     DO DBCLOSE WITH "MAIL,STATE" ~4



























                         
     ~4 Use DBCLOSE to close all other databases except those defined.
                                     - Page 49 -


                                 Basic Installation



     After exiting the EDIT procedure, the database filters will be reset,
     and all data in memory is FLUSHed.


                          Invoking the OPTION procedure


     Our main module has initialized all DOS environment and system
     variables.  Now we can invoke the OPTION procedure.


                             Initial Variable values


     To invoke the option procedure, you need to set the following variables:

          bPR_DRAFT = flag, .t. = draft mode, .f. = non-draft mode
          bSIDEWAYS = flag, .t. = call sideways, .f. = enable sideways
          nFORM_SCR = # of the full screen/option grid input form
          cPRN      = device name (print device, file name, or CON)

     If cPRN is not defined, the option grid will appear.  The user will be
     able to press [C] to continue, and [Q] to quit.  If the user presses [Q]
     to quit, LASTKEY() will have 27 as a value.

     If cPRN is specified, the option grid will appear.  The user will be
     able to press [S] for screen output, [P] to printer output, or [Q] to
     quit.  Again, if the user presses [Q] to quit, LASTKEY() will have 27 as
     a value.

     If the user presses [S] or [P], the option grid will call a procedure
     named PRINT.  This user defined procedure, PRINT, must create a file
     defined as cFILE.  Having created cFILE, option [S] will display it.
     Option [P] will copy this file to the print device specified by cPRN.

     Note:  For people converting foxbase reports, nFORM_SCR can be set to
     zero.  No grid is displayed, and the update mode is disabled.  But the
     screen and print modes are still available.


                                    Draft Mode


     There are two ways to print cFILE:  Draft mode and non-draft mode.
     Setting the variable bPR_DRAFT to either true or false.  In draft mode,
     the report file is copied directly to the print device.  Under MS-DOS
     Windows, draft mode bypasses the print spooler.  In non-draft mode, the
     report file is copied to the print device via the print spooler.




                                     - Page 50 -


                                 Basic Installation


                                     SIDEWAYS


     If you have a wide column report, initialize the variable bSIDEWAYS.
     Then the PRINT procedure can set bSIDEWAYS to true for a wide column
     (landscape) report, false for a normal (portrait) report.  Or you can
     set bSIDEWAYS to true before invoking OPTION and force the report to
     print sideways.

     When the option grid report is printed, the print dialog is checked.  If
     landscape mode is set, the variable bSIDEWAYS is automatically set to
     true.  Sideways output is sent to cPRN via the print spooler.  If
     bSIDEWAYS is true and the program SIDEWAYS.COM (by Funk Software) exists
     in the cMEMPATH directory, cFILE is copied to that directory and
     SIDEWAYS.COM is executed.


                                 Executing OPTION


     Once you defined a screen database, it takes very little code to use an
     option grid.  The following, for example, provides all the code needed
     to call an option grid:

     *
     *    GET OPTION GRID
     *
     DO WINDOW WITH "MALPR1", "Mailing List Report"
     nFORM_SCR = 15
     SELECT MAIL
     SCATTER MEMVAR BLANK
     STORE {  /  /  } TO M->BIRTH2, M->USER_DAT2, M->ACT_DATE2
     STORE SPACE(50) TO M->MESS
     STORE "B" TO cADDR_TYPE
     STORE 1 TO nINDEX, nORDER
     cPRN = cPR_PRN
     DO OPTION
     DO WINDOW WITH "MALPR1", .F.


     Note:  This code resides in our report module.  Also contained in our
     module is the procedure called PRINT.  See one of the dMAIL4 reports for
     details.










                                     - Page 51 -


                                Advanced Installation




                           Installing a header editor


     Suppose, for example, that we wanted to create an invoice editor.
     From within it, we wanted the ability to edit invoice detail records.
     What we want is to add an option to the EDIT procedure and to handle
     detail records.

     The EDIT and OPTION procedures have the ability to add options.
     Basically, you perform the following:

          DO EDIT WITH .T.

     Specifying '.T.' adds one extra line to the option grid.  Both EDIT
     and OPTION procedures will allow extra line(s) in the prompt window.
     If you specify:

          DO EDIT WITH 2

     ..then two extra lines are added.  You may also specify no extra lines
     as in:

          DO EDIT WITH .F.

     In each instance, however, EDIT or OPTION will now execute the
     following procedures:  PROMPT, CHOICE, WHEN, and VALID.  PROMPT will
     contain code for the added prompts, CHOICE will execute these choices.
     The WHEN procedure will be executed before any update.  The VALID will
     be executed after an update, browse, deletion, or recalled function.

     The following procedure file will illustrate:


     * PROGRAM INV_EDIT.PRG
     * PROGRAMMER D. ALLEN
     * CREATED MAY 20, 1991
     * UPDATED DEC 20, 1993
     * COPYRIGHT(C) 1990
     *
     *    THE PURPOSE OF THIS PROCEDURE IS TO ALLOW THE USER TO
     *    CREATE/MAINTAIN RECORDS IN THE INVOICE DATABASE SYSTEM.
     *
     DO EDIT WITH .T.
     RETURN
     *
     PROCEDURE PROMPT
     *
     *    THE PURPOSE OF THIS PROCEDURE IS TO ADD PROMPTS.
     *
     DO GET WITH 00,12, "\<Edit Details"
     cCHOICES = cCHOICES + "E"
                                     - Page 52 -


                                Advanced Installation


     RETURN
     *
     PROCEDURE CHOICE
     *
     *    THE PURPOSE OF THIS PROCEDURE IS TO EXECUTE CHOICES.
     *
     PRIVATE cCHOICE
     cCHOICE = IIF(mCHOICE > 0,SUBSTR(cCHOICES,mCHOICE,1),"")
     DO CASE
     CASE cCHOICE = "H"
       DO WINDOW WITH "GET_HELP", " H E L P "
       @ 0,0 CLEAR
       TEXT
       Command prompt

         [E]dit Details  -  Allows the user to create/maintain
                            invoice details

       ENDTEXT
       WAIT WINDOW
       DO WINDOW WITH "GET_HELP", .F.
     CASE cCHOICE = "E"
       IF .NOT. bDISPLAY
         DO ERR WITH "Edit what?"
         RETURN
       ENDIF
       PRIVATE cFILE
       nINV_NO=INV_NO
       cFILE=fnFILE()  && generates unique filename w/ tmp extension
       SAVE TO (cFILE)
       STORE  .F.  TO bEXACT, bUNIQUE
       STORE    "" TO cBROWSE, cINDEX
       STORE ".T." TO cFILTER
       DO WINDOW WITH "INV_EDIT", "Invoice Details"
       nFORM_NDX=7
       nFORM_SCR=8
       SELECT INV_DET
       cBROWSE="KEY nINV_NO"
       cFILTER="INV_NO=nINV_NO"
       SET EXACT OFF
       SEEK nINV_NO
       SET EXACT ON
       bUNIQUE=.F.
       DO EDIT
       DO WINDOW WITH "INV_EDIT", .F.
       RESTORE FROM (cFILE) ADDITIVE
       DELETE FILE (cFILE)
       DO FLD_SAY&cFORM_SCR
       RETURN
     ENDCASE
     RETURN
     *
     PROCEDURE WHEN
                                     - Page 53 -


                                Advanced Installation


     *
     *    THE PURPOSE OF THIS PROCEDURE IS TO INITIALIZE A RECORD.
     *
     RELEASE _INV_NO
     PUBLIC  _INV_NO
     IF bADD
       SELECT 0
       USE (cDATAPATH+"SYSDATA") EXCLUSIVE ALIAS SYSDATA
       STORE SYS_INV TO M->INV_NO, _INV_NO
       REPLACE SYS_INV WITH SYS_INV + 1
       USE
     ENDIF

     && PRIVATE _DELETE, _RECALL
     && _DELETE = IIF(DELETED()       .AND. SET("DELETE") = "ON", .T.,.F.)
     && _RECALL = IIF(.NOT. DELETED() .AND. SET("DELETE") = "OFF",.T.,.F.)
     && IF (_DELETE .OR. _RECALL) .AND. .NOT. bINIT
     &&   DO ERR WITH "Cannot execute.  System administration function."
     &&   STORE .F. TO bSAVED
     &&   RETURN
     && ENDIF
     RETURN
     *
     PROCEDURE VALID
     *
     *    THE PURPOSE OF THIS PROCEDURE IS TO VALIDATE A RECORD.
     *
     PRIVATE _DELETE, _RECALL
     _DELETE = IIF(DELETED()       .AND. SET("DELETE") = "ON", .T.,.F.)
     _RECALL = IIF(.NOT. DELETED() .AND. SET("DELETE") = "OFF",.T.,.F.)
     IF .NOT. bSAVED
       IF bADD
         SELECT 0
         USE (cDATAPATH+"SYSDATA") EXCLUSIVE ALIAS SYSDATA
         IF _INV_NO = SYS_INV - 1
           REPLACE SYS_INV WITH SYS_INV - 1
         ENDIF
         USE
         RELEASE _INV_NO
       ENDIF
       RETURN
     ENDIF
     IF bADD .OR. .NOT. bSAVED
       RELEASE _INV_NO
       RETURN
     ENDIF
     IF .NOT. _DELETE .AND. .NOT. _RECALL ;
      .AND. _INV_NO = M->INV_NO
       RELEASE _INV_NO
       RETURN
     ENDIF
     SELECT INV_DET
     SET EXACT OFF
                                     - Page 54 -


                                Advanced Installation


     SEEK _INV_NO
     SET EXACT ON
     DO WHILE .NOT. EOF() .AND. INV_NO = _INV_NO
       IF .NOT. fnRLOCK()
         EXIT
       ENDIF
       REPLACE INV_NO WITH M->INV_NO
       IF _DELETE
         DO DELETE
       ENDIF
       IF _RECALL .AND. DELETED()
         RECALL
       ENDIF
       DO ALTER
       UNLOCK
       IF INV_NO = _INV_NO
         SKIP
         LOOP
       ENDIF
       SET EXACT OFF
       SEEK _INV_NO
       SET EXACT ON
     ENDDO
     RELEASE _INV_NO
     SELECT (nDBF)       && EDIT saves the current work area as nDBF
     mALTER = fnALTER()  && see multi-user section
     RETURN


     The PROMPT procedure defines a single push button @ GET and adds the
     choice "E" to the list of available choices.

     Now let's talk about the CHOICE procedure.  Given the choice of "E",
     the CHOICE procedure saves all memory variables to a file.  The
     invoice detail work area is selected, the first detail is found, and
     the EDIT procedure is performed.  Upon returning from the detail
     editor, the memory file is restored.

     Notice that we had to define two kinds of filters.  cFILTER tells EDIT
     to look at only detail records of the current invoice.  cBROWSE tells
     the BROWSE command to look at only detail records of the current
     invoice.

     Now let's look at the WHEN and VALID procedures.  The WHEN procedure
     saves the invoice number (In add mode it actually grabs the next
     available invoice number from a counter file).  The user is allowed to
     change the invoice number.  The VALID procedure will then maintain any
     changed invoice numbers for all detail records.  Notice that the VALID
     procedure is capable of deleting details if the header is deleted, and
     recalling details if the header was recalled.



                                     - Page 55 -


                                Advanced Installation


     Note:  The WHEN procedure can also prevent the user from deleting the
     current record (See commented code).  Set bSAVED to false if deleting
     or recalling a record cannot occur.


                                Multiple Screens


     In our previous example, let's suppose our invoice header contained
     lots of fields.  More than could fit on one screen.  So we need a
     second input screen.  Well, there's two ways we could handle this
     event.  Both involve using the OPTION procedure.

     In the first method, we'd add an extra choice to INV_EDIT.PRG.  To add
     another choice, add the following code to the PROMPT procedure:

     DO GET WITH 00,32, "\<Sales"
     cCHOICES = cCHOICES + "S"


     Also add the following code to the CHOICE procedure:

     CASE cCHOICE = "S"
       IF .NOT. bDISPLAY
         DO ERR WITH "Edit what?"
         RETURN
       ENDIF
       PRIVATE cFILE
       cFILE=fnFILE()
       SAVE TO (cFILE)
       DO WINDOW WITH "INV_EDIT", "Sales"
       nFORM_SCR=9
       DO SLS_EDIT
       DO WINDOW WITH "INV_EDIT", .F.
       RESTORE FROM (cFILE) ADDITIVE
       DELETE FILE (cFILE)


     We've defined a procedure called SLS_EDIT, rather than calling OPTION
     directly.  That way, we have a separate set of PROMPT, CHOICE, WHEN,
     and VALID procedures.  The following will illustrate SLS_EDIT.PRG:


     * PROGRAM SLS_EDIT.PRG
     *
     DO OPTION WITH .F.
     RETURN
     *
     PROCEDURE PROMPT
     RETURN
     *
     PROCEDURE CHOICE
     RETURN
                                     - Page 56 -


                                Advanced Installation


     *
     PROCEDURE WHEN
     RETURN
     *
     PROCEDURE VALID
     IF bSAVED
       SELECT (nDBF)
       IF fnRLOCK()
         mALTER = fnALTER()  && see multi-user section
         GATHER MEMVAR
         DO ALTER WITH CHR(mALTER)
         UNLOCK
       ENDIF
     ENDIF
     RETURN


     When the option grid is completed, the VALID procedure of SLS_EDIT.PRG
     will update the invoice header.

     In our second method, when the first invoice header screen is
     completed/updated, we prompt the user with the second screen.  Instead
     of adding an option to the PROMPT and CHOICE procedures, we add the
     following code to the VALID procedure in INV_EDIT.PRG:

     IF bDISPLAY .AND. bSAVED
       PRIVATE cFILE
       cFILE=fnFILE()
       SAVE TO (cFILE)
       DO WINDOW WITH "INV_EDIT", "Sales"
       nFORM_SCR=9
       DO SLS_EDIT
       DO WINDOW WITH "INV_EDIT", .F.
       RESTORE FROM (cFILE) ADDITIVE
       DELETE FILE (cFILE)
     ENDIF


     Note:  To prevent code execution during a browse, the value of
     bDISPLAY must be true.

     As in the first method, we make the same call to SLS_EDIT.PRG.  For
     the same reasons.  In SLS_EDIT.PRG, however, we'll replace:

     DO OPTION WITH .F.

     ..with:

     DO OPTION WITH 0




                                     - Page 57 -


                                Advanced Installation


     A zero parameter tells the OPTION procedure there is no option grid.
     OPTION will perform the initial input screen.  Regardless is the
     screen is completed or not, however, control is immediately returned
     to the calling procedure.

     Note:  In both multiple-screen methods, our second input screen is an
     option grid.  Remember that an option grid requires memory variables
     in the GET_NAME field.


                           Multi-User Considerations


     All multi-user databases need a one character ALTER field to insure
     data integrity.  The EDIT procedure stores the current ALTER value in
     the variable mALTER.  mALTER is used to prevent GAVER MEMVAR from
     wiping out the current value.

     Typically, you would use the following code to maintain the ALTER
     field:

             IF fnRLOCK()
               REPLACE UPDATED WITH DATE()
               DO ALTER
               UNLOCK
             ENDIF


     For a REPLACE ALL, you need to use the fnALTER(1) UDF:

             IF fnFLOCK()
               REPLACE ALL UPDATED WITH DATE(), ALTER WITH CHR(fnALTER(1))
               UNLOCK
             ENDIF


     For a SCATTER/GATHER, you would have to execute slightly different
     code:

             IF fnRLOCK()
               SCATTER MEMVAR                && M->ALTER exists
               mALTER = fnALTER()
               :
               STORE DATE() TO M->UPDATED
               :
               GATHER MEMVAR
               DO ALTER WITH CHR(mALTER)
               UNLOCK
             ENDIF


     Finally, if you have a VALID clause that updates multiple files you
     need to reset mALTER.
                                     - Page 58 -


                                Advanced Installation



     SELECT (nDBF)
     mALTER = fnALTER()  && see multi-user section

     Note:  The variable nDBF is created by the EDIT procedure to save the
     current work area.















































                                     - Page 59 -


                                Advanced Installation


                                   Final Word


                           Generating Hard-Wire Code


     Up until now, the various SCRPROC.PRG procedures have been retrieving
     information from the SCR.DBF data dictionary directly.  This is an
     interpreted mode.  When you enter an editor, for example, a "beep"
     indicates you are in interpreted mode.

     Once you have your database(s) well defined, you may wish to "hard-
     wire" your data dictionary.  That is, generate executable code from
     the SCR.DBF dictionary.  This generated code improves I/O
     significantly.

     The process is simple.  First, you must be in the directory containing
     your SCR.DBF file.  Then, at the Foxpro 2.6 command window, type:

               DO   C:\HW4\HW4.FXP

     and press [Enter].  From the Visual Foxpro command window, you would
     type:

               DO   C:\HW4\VHW4.APP

     and press [Enter] (where C:\HW4 contains Hard Wire Four).  Hard Wire
     Four will generate a file called "SCR.PRG".  If there are "FXP" files
     in the current directory, "SCR.PRG" will be compiled.

     SCR.PRG contains all the hard-wired versions FLD_FND, FLD_GET and
     FLD_SAY routines.  The various SCRPROC.PRG procedures will now use
     SCR.PRG.  SCR.DBF is used only to retrieve help text.

     To add/delete/change records in the SCR.DBF data dictionary, first
     delete the files SCR.PRG and SCR.FXP.  You are once again in
     interpreted mode.  Make your changes and run HW4 again.


                               Creating a project


     If you modeled your application after dMAIL4, and have generated a
     SCR.PRG, you should then be able to create a Foxpro project.  Simply
     add the main startup program module to an empty project.  The other
     modules, including SCR.PRG, should get pulled into the project
     automatically.






                                     - Page 60 -


                                Advanced Installation


                                   FORM = -1


     I've recently added a form = -1 to the screen database.  When a
     SCR.PRG is generated, any record with a form = -1 will be checked for
     a SAY_TXT statement.  Such SAY_TXT statements will be included in the
     top of the SCR.PRG module.

     This new feature will allow you to include EXTERNAL ARRAY and other
     declarations.  So that your SCR.PRG can have arrays and still compile
     correctly within a project.


                                  Distribution


     If you decide to create an application using Hard Wire Four, please
     add the following copyright notices to your installation:


          Copyright Notices:

          SCR.DBF Data Dictionary supplied by Dennis Allen
          EXPRMENU is supplied by Robert A. Pope DDS


                                   Conclusion


     At this point, you should begin to get the idea on how my data
     dictionary works.  But even if you haven't, don't despair.  It took me
     over a decade to develop this data dictionary approach.

     I have other Foxpro applications based on this data dictionary method.
     If you get one, you'll notice it looks and feels very much like
     dMAIL4.  There's something to be said for standardization.  Good luck!

















                                     - Page 61 -


                                     Appendix A


     The Hard Wire System contains the following files:

     DATA_BLD APP   DATA_BLD PJT   DATA_BLD PJX   DATA_BLD PRG
     DATA_BLD SCT   DATA_BLD SCX   DATA_BLD SPR   GENERIC  FXP
     GENERIC  PRG   FILE_ID  DIZ   HW4      DOC   HW4      FXP
     HW4      MAN   HW4      PRG   Q_DBFS    PRG  Q_README TXT
     READ     ME    SCRDBFS  FXP   SCRDBFS  PRG

     Files with a .PRG extension are Foxpro source files.  The files with a
     .FXP or .APP extension are Foxpro 2.6 object modules.  Files with a
     .APP extension, and prefixed with a "V", are Visual Foxpro object
     modules.  The "V" avoids conflict with Foxpro 2.6 APP/FXP files.

     The files with a .DOC extension are MS Word Documents.  Files with a
     .MAN extension are ASCII output files of MS Word documents.  HW4.MAN
     is the Hard Wire Four manual.  A copy of the manual can be printed
     simply by typing "COPY HW4.MAN PRN" at the DOS prompt.

     All ????_BLD.* files belong to the DATA_BLD application.  This program
     generates the code need for Robert Pope's expression builder.

     GENERIC.PRG was included to translate a Generic/Text Only  *.PRN file
     to an ASCII *.MAN file.  See Appendix C.

     Q_DBFS.PRG is a procedure that will create/verify all Q*.* files.  It
     was generated from the Data-Wire Four program and is now included in
     all my applications.  See Appendix B, expression builder.

     SCRDBFS.PRG was included to create and verify the SCR.DBF data
     dictionary.  It was generated from the Data-Wire Four program.























                                     - Page 62 -


                    Appendix B/ Robert Pope's Expression Builder



     In the system setup menu of dMAIL4 there is a call to Robert Pope's
     expression builder.  The expression builder allows you to select a
     record filter from a list of record filters.  A record filter defines
     those records in a database that can be viewed, edited, or printed.

     The expression builder is a self-contained program called
     EXPRMENU.PRG.  It uses it's own data dictionary, stored in q*.* files,
     to define expressions.  To create a data dictionary for your own
     databases is simple process.

     For example, suppose you wanted to create a new data dictionary for a
     CLIENT.DBF file.  From the command window, you would first perform a
     'USE CLIENT' to open the file.  Then, you would 'DO DATA_BLD' to
     execute the DATA_BLD application, (included with HW4).  Answer the
     initial questions and define the labels needed for each data field.
     Your work will be saved in files called QCLIENT.DBF, QCLIENT.FPT, and
     QCLIENT.CDX and will generate a file call QCLIENT.PRG.

     If you need to modify the properties of this data dictionary, simply
     copy the QCLIENT.* database files to Q_DATA.* files.  Then run
     DATA_BLD and select 'Modify Current Q_DATA file'.

     After generating your data dictionary, use the following code to call
     exprmenu.prg:


     STORE ".T."   TO cCL
     STORE ""      TO cCL_NAME
     STORE "QCLIENT" TO cFILE
     SELECT CLIENT
     SET FILTER TO .T.
     *
     STORE "" TO cTEMP, cTEMP2
     cTEMP = EXPRMENU(cFILE,cFILE,@cTEMP2)
     DO RELEASE
     *
     IF LASTKEY() = 27 .OR. TYPE("cTEMP") <> "C" .OR. cTEMP = ""
       RETURN
     ENDIF
     cTEMP = "(" + cTEMP + ")"
     *
     SELECT CLIENT
     IF TYPE(cTEMP) <> "L"
       DO ERR WITH "Error:  Filter does not return logical value"
       STORE ".T." TO cTEMP
       STORE    "" TO cTEMP2
     ENDIF
     SET FILTER TO &cTEMP
     cCL = FILTER()
     cCL_NAME = ALLTRIM(cTEMP2)

     IF .NOT. (&cTEMP)
                                     - Page 63 -


                    Appendix B/ Robert Pope's Expression Builder


       GO TOP
     ENDIF


     Upon exiting exprmenu.prg, the public variable cCL will contain the
     selected filter.  The public variable cCL_NAME will contain the
     selected filter name.  Notice that if the user press [Esc] to exit
     exprmenu.prg, the filter is reset to '.T.'.

     Note:  The 'DO RELEASE' just resets the current window as active.

     If you look at MALSYS.PRG, a bit more code is used.  Basically, this
     code ensures that each user has his/her own set of q*.* files in their
     user resource directory.  If you just want one common set of
     expressions, remove this code (and the SET DEFAULT TO lines).

     Oh, I also recently added code to call Q_DBFS.PRG.  This procedure was
     generated by my Data-Wire Four application.  Q_DBFS.PRG will simply
     create/verify all Q*.* files.  Since Q_DBFS.PRG will CLOSE DATABASES
     upon exit, I also had to add a call "DO INITIAL" to reopen my files
     afterwards.

     If you need to know more about the expression builder, see the file
     called Q_README.TXT.





























                                     - Page 64 -


                               Appendix C/ GENERIC.PRG


     I've recently converted my ancient MS Word 5.0 for DOS user &
     configuration manuals to MS Word 97 files.  These files, however,
     cannot be viewed within Foxpro.  That is, readable via MODIFY FILE.

     I've been using the Windows 95 "Generic/Text Only" printer device to
     create PRN files.  PRN files, while close, are not in pure ASCII form.

     GENERIC.PRG was created to translate a PRN file to an ASCII file.
     carriage returns are converted to carriage return/linefeeds.  Lines
     will have a maximum length of 80 characters.

     A formfeed marks the end of a page.  A maximum of 60 lines/formfeed is
     allowed (making the ASCII file compatible with either dot matrix or
     laser printers).  Blank lines will be removed for pages exceeding 60
     lines/formfeed.

     Oh, any carriage return/linefeed after the final formfeed will also be
     removed.  You can thus copy your ASCII file straight to the printer.
     It should not leave an extra print line to interfere with the next
     print output.

     To use GENERIC is simple.  At the command window, type DO GENERIC.
     You will be prompted for the input file (default extension PRN) and
     the output file (default extension MAN).  After creating the output
     file, you will again be printing for another input and output file.
     Press [Esc] to exit.

     If you execute GENERIC with the input and output file names as
     parameters, you will not be prompted.  When the output file is
     created, the input file is deleted and you will be returned to the
     command window.

     Programmers note:  GENERIC will create a temporary file, file
     extension TMP.  If a page has more than 60 lines, you can edit the TMP
     file and use it as an input file.  Don't edit the original PRN file
     from Foxpro.  Too impredictable.  Oh, but remember to delete the PRN
     file afterwards.
















                                     - Page 65 -


                                      GLOSSARY


     _ALIAS  -  Saved alias and record pointers.  Internal.

     _COLOR  -  Saved original color scheme.  Internal.

     _CHANGE  -  Internal.

     _COLORSET  -  Default color set.  Internal.

     _DELETE  -  Internal.

     _DIALOG  -  Variable array of dialog window names.  Internal.

     _FLD  -  Internal.

     _GOTO  -  Saved goto window name.  Internal.

     _OBJ  -  Internal.

     _TAB  -  Internal.

     _THERM  -  Variable array of thermometer window names.  Internal.

     _VIEW  -  Saved SET view file name.  Internal.

     bADD  -  Used in BROWSE, EDIT, and OPTION procedures.  Set to true for
          add mode, false for update mode.

     bANSI  -  GETENV('TERM').  If false, not full ANSI implementation.  Only
          24 lines.  Use [Ctrl]-[Q] instead of [Esc].

     bBLK  -  If true, procedures CTR & SAY will blink specified text.

     bDEBUG  -  LEN(GETENV('DEBUG'))>0.  If true, debug Mode on.  [Alt]-[D]
          will invoke debug menu.

     bDISPLAY  -  FLD_SAY executed, record is displayed.  Allow user input.

     bEXACT  -  If true, procedure FLD_FND must find exact match.

     bGETFILE  -  Flag, using dialog box in fnGETFILE().  Internal.

     bINIT  -  LEN(GETENV('INIT'))>0.  If true, system Administration
          enabled.

     bINT  -  If true, procedures CTR & SAY will display text with intensity
          on.

     bINV  -  If true, procedures CTR & SAY will display text with inverse
          on.

     bLOCATE  -  The procedure FLD_FND will set true if wildcard LOCATE is in
          effect.

                                     - Page 66 -


                                      GLOSSARY


     BLOCATE2  -  Equals true if no index on locate.

     bMULT  -  GETENV('MULT')<>'ON'.  If true, Multi-user mode is in effect.

     bNO_CDX  -  If true, the next dbf in USE does not have to have a CDX
          file.  Error 1707 is ignored by error handler.

     bNO_ERR  -  If true, any error in called procedure will set bNO_ERR to
          false.  You will be returned to calling procedure.

     bNO_INT  -  If true, procedures CTR & SAY will display text with
          intensity off.

     bPR_DRAFT  -  If true, print in draft mode.

     bRECALL  -  LEN(GETENV('RECALL'))>0.  If true, deleted records are not
          blanked and re-used.  They can be recalled.

     bSAVED  -  Used in BROWSE, EDIT, and OPTION procedures.  If true, record
          was saved.

     bSIDEWAYS  -  Used in OPTION procedure.  If true, print report sideways
          (landscape) mode.  If false, enable sideways mode.

     bUNIQUE  -  If true, procedure FLD_UNQ will check for key uniqueness.

     cBORDER  -  GETENV('BORDER').  Customized border characters.

     cBROWSE  -  SET FILTER string internal to the BROWSE command within the
          EDIT procedure.

     cCHOICE  -  Menu choice.  Internal.

     cCHOICES  -  Menu choices available.  Internal.

     cDATAPATH  -  GETENV('DATA').  Path for all data files..

     cDRIVE_SEP  -  Drive & Path Separator.  Operating system specific.
          Internal.

     cFILTER  -  SET FILTER string internal to EDIT procedure.

     cFONT  -  If not null, procedures CTR, SAY, and WINDOW will use
          specified font.  Foxpro for windows only.

     cFORM_NDX  -  String form of nFORM_NDX.

     cFORM_SCR  -  String form of nFORM_NDX.

     cINDEX  -  Variable array.  Invokes toggle option in EDIT procedure.
          Also checks for multiple-key uniqueness.

     cMASTER  -  File Name of master procedure.
                                     - Page 67 -


                                      GLOSSARY



     cMEMPATH  -  Path for all MEMory files.  Derived from SYS(2005).

     cPATH_SEP  -  Path Separator.  Operating system specific.  Internal.

     cPR_???  -   Printer control codes.

     cPROGPATH  -  GETENV('PROG').  Path for all program files..

     cREINDEX  -   Program name for reindex utility.  Callable from error
          handler.

     cSTYLE  -  If not null, procedures CTR, SAY, and WINDOW will use
          specified font style.  Foxpro for windows only.

     cSYSTEM  -  System memory file name.  Unique to each user, it's the
          preferred place for printer codes.

     cTEMPPATH  -  GETENV('TEMP').  Path for all temporary files..

     cWINDOW  -  Variable array.  Names of all active windows.  See procedure
          WINDOW.  Internal.

     LOC_nn  -  Saved LOCATE command for form nn.  Internal.

     mALTER  -  ALTER is the one-character field used to maintain multi-user
          data integrity.  mALTER is the CHR(ALTER) value of the current
          record and is used throughout the system.

     mCHOICE  -  Numeric form of cCHOICE.  Internal.

     mGET  -  Current @ GET variable, used in GET procedure.  Internal.

     mMEMO  -  Memo array.  For use, see fnMEMO() in procedure file.
          Internal.

     nCOL  -  Column position of current field.  If column and row equal
          zero, do not display (probably a browse).

     nFONT  -  If not zero, procedures CTR, SAY, and WINDOW will use
          specified font size.  Foxpro for windows only.

     nFORM_NDX  -  Form screen number.

     nFORM_SCR  -  Form index number.

     nLEVEL  -  Current window level in cWINDOW().  See procedure WINDOW.
          Internal.

     nMEMOWIDTH  -  Default memo width.

     nPR_???  -   Printer control codes.

                                     - Page 68 -


                                      GLOSSARY


     nPR_COLnn  -   Saved Goto Window, column position in form nn.

     nPR_MCLnn  -   Saved memo Window, column position in memo nn.

     nPR_MC2nn  -   Saved memo Window, column size in memo nn.

     nPR_MRWnn  -   Saved memo Window, row position in memo nn.

     nPR_MR2nn  -   Saved memo Window, row size in memo nn.

     nPR_ROWnn  -   Saved Goto Window, row position in form nn.

     nREFRESH  -  GETENV('REFRESH').  Multi-user refresh rate.

     nROW  -  Row position of current field.  If column and row equal zero,
          do not display (probably a browse).

     nSCHEME  -  If not zero, procedures CTR, SAY, and WINDOW will display
          specified text/window in COLOR SCHEME nSCHEME.

     nSTART  -  Starting screen row of all active windows.  See procedure
          WINDOW.

     nTO_READ  -  TIMEOUT value for all FLD_GET procedure READs.

     nWINDOW  -  Variable array.  COLOR SCHEMEs of all active windows.  See
          procedure WINDOW.  Internal.


























                                     - Page 69 -


                                        Index

     .APP, 62                            cINDEX, 45, 48, 67
     .FXP, 62                            cMASTER, 67
     .PRG, 62                            cMEMPATH, 36, 68
     ?PR_*, 41                           Conclusion, 61
     _ALIAS                              cPATH_SEP, 68
     _CHANGE, 66                         cPR_???, 68
     _COLOR, 66                          cPRN, 50
     _COLORSET, 66                       cPROGPATH, 68
     _DELETE, 66                         Creating a project, 60
     _DIALOG, 66                         cREINDEX, 68
     _FLD, 66                            cSTYLE, 68
     _GOTO
           , 66
          , 66                           cSYSTEM, 41, 68
     _OBJ, 66                            cTEMPPATH, 68
     _TAB, 66                            Customized BROWSE, 48
     _THERM, 66                          cWINDOW, 68
     _VIEW, 66                           DATA_BLD, 62, 63
     ALTER, 6, 58                        Data-Wire Four, 62, 64
     ASCII, 65                           Defining a database field, 11
     bADD, 44, 66                        Defining a field description,
     bANSI, 66                            10, 24, 27
     bBLK, 66                            Defining a memo field, 29
     bDEBUG, 66                          Defining a Memo Field, 13
     bDISPLAY, 15, 29, 44, 46, 66        Defining an @ EDIT field, 13
     bEXACT, 47, 66                      Defining an input field, 24, 28
     bGETFILE, 66                        Defining dMAIL4, 5
     bINIT, 37, 66                       Defining the [F]ind Type Form,
     bINT, 38, 66                         24
     bINV, 38, 66                        Defining the Data Dictionary
     bLOCATE, 44, 66                      Layout, 7
     bLOCATE2, 67                        Defining the form number, 9
     bMULT, 37, 67                       Defining the Full Screen Form,
     bNO_CDX, 67                          10
     bNO_ERR, 67                         Defining the Option Grid Form,
     bNO_INT, 67                          27
     bPR_DRAFT, 50, 67                   Displaying @ EDIT field, 28
     bRECALL, 67                         Distribution, 61
     bSAVED, 44, 46, 67                  dMAIL4, 1, 41
     bSIDEWAYS, 50, 67                   dMAIL4 Data Dictionary, 34
     bUNIQUE, 45, 47, 67                 Draft mode, 50
     Calculated fields, 20               Draft Mode, 50
     cBORDER, 67                         edit, 47
     cBROWSE, 48, 55, 67                 Executing EDIT, 48
     cCHOICE, 67                         Executing OPTION, 51
     cCHOICES, 67                        EXPRMENU.PRG, 63
     cDATAPATH, 67                       filter, 63
     cDRIVE_SEP, 67                      Final Word, 60
     cFILE, 50                           fnCHOICE, 40
     cFILTER, 55, 67                     fnGETENV, 36
     cFONT, 67                           fnPATH, 36
     cFORM_NDX, 44, 67                   form, 9, 10
     cFORM_SCR, 43, 67                   FORM, 7
     CHOICE, 52                          FORM = -1, 61
                                     - Page 70 -

                                        Index

     Foxpro, 1                           nROW, 15, 29, 69
     Foxpro for Windows, 12              nSCHEME, 69
     framework, 35                       nSTART, 39, 69
     FUNCTION BRV, 42                    nTO_READ, 23, 33, 69
     FUNCTION BRW                        nWINDOW, 69
     FUNCTION YESNO, 41                  OPTION, 50
     Generating Hard-Wire Code, 60       Other Main Module Code, 41
     GENERIC.PRG, 62, 65                 PRINT, 50
     hard-wire, 60                       PRN, 65
     Hard-Wire, 34                       PROCEDURE CTR, 38
     hard-wired, 44                      PROCEDURE EDIT, 42
     HW4
                 , 43
        , 1                              PROCEDURE FLD_BRO, 43
     INITIAL, 49                         PROCEDURE FLD_DES(), 43
     Initial Variable values, 47, 50     PROCEDURE FLD_FND, 43
     Initializing Variables, 35          PROCEDURE FLD_GET, 44
     Installing a header editor, 52      PROCEDURE FLD_POP, 44
     interpreted mode, 34, 44, 60        PROCEDURE FLD_SAY, 44
     Invoking the BROWSE procedure,      PROCEDURE FLD_SHW, 45
      47                                 PROCEDURE FLD_TXT, 45
     Invoking the EDIT procedure, 47     PROCEDURE FLD_UNQ(), 45
     Invoking the OPTION procedure,      PROCEDURE FLD_UQS(), 45
      50                                 PROCEDURE GET, 40
     little black box, 42                PROCEDURE OPT_GET, 46
     LOC_nn, 68                          PROCEDURE OPT_SAY, 46
     Main Menu Loop, 38                  PROCEDURE OPT_TXT, 46
     Main Module, 35                     PROCEDURE OPTION, 46
     MAL.PRG, 35, 41                     PROCEDURE WINDOW, 39
     MALSYS.PRG, 62, 64                  PROMPT, 52
     mALTER, 58, 68                      Q_DBFS.PRG, 62, 64
     MAN, 65                             record filter, 63
     mCHOICE, 68                         SCR.DBF, 1, 7, 34, 35, 60, 62
     memo, 13, 29                        SCR.FXP, 34
     mGET, 68                            SCR.PRG, 34, 44, 60, 61
     mMEMO, 68                           SCRDBFS.PRG, 62
     Multiple Indices, 48                SCRPROC.PRG, 35, 42, 60
     Multiple Screens, 56                SIDEWAYS, 51
     Multi-User Considerations, 58       Size Fields, 12
     nCOL, 15, 29, 68                    SIZE_1, 12, 13, 28
     nDBF, 55, 59                        SIZE_2, 12, 13, 28
     nFONT, 68                           SIZE_3, 13, 28
     nFORM_NDX, 44, 47, 68               The BROWSE clause, 17
     nFORM_SCR, 43, 47, 50, 68           The Default clause, 17, 25, 30
     nLEVEL, 39, 68                      The Description clause, 22, 32
     nMEMOWIDTH, 13, 68                  The GET_MEMO clause, 21, 26, 31
     non-draft mode, 50                  The GET_READ clause, 23, 27, 32
     nPR_???, 68                         The Message clause, 20, 25, 30
     nPR_COL, 69                         The Popup clause, 21, 26, 31
     nPR_MC2, 69                         The Restore clause, 19, 25, 30
     nPR_MCL, 69                         The Second Message clause, 21,
     nPR_MR2, 69                          26, 31
     nPR_MRW, 69                         The WHEN clause, 16, 25, 30
     nPR_ROW, 69                         VALID, 52
     nREFRESH, 69                        Validating a database field, 14
                                     - Page 71 -


                                        Index


     Validating an input field, 24,      WHEN, 52
      29                                 YESNO, 41



















































                                     - Page 72 -  